/*************
 ޸.
 *************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

#define   BATCHNUM      1               /* ÿĿ */

static char *t_pzftp = NULL;            /* ZFTPƽַ̨ */

typedef struct  s_batfilter             /* ޸Ĺṹ */
{
    char    szCheckFlag[32];            /* ر־ */
    char    szFilDesc[65];              /*  */
    char    szFilIP[17];                /* IP */
    char    szFilNo[17];                /* ɼ */
    char    szFilSrcPath[129];          /* Դ· */
    char    szFilDstPath[129];          /* Ŀ· */
    char    szFilAnalyzer[65];          /*  */
    char    cFilOperType;               /*  */
    int     iFilOperType;               /*  */
    int     iFilSeqCtrl;                /* Ƿſ */
} BATFILTER;

/**************************
 ƥ
 ֵ  1 ƥ  0 ƥ
 ***************************/
static int f_filter(BATFILTER *pFilter)
{
    /*  */
    if( pFilter->szCheckFlag[0] == '1' )
    {
        if( pFilter->szFilDesc[0] )
        {
            if( strstr(u_pcfgs->desc, pFilter->szFilDesc) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->desc[0] ) return(0);
        }
    }

    /* IP */
    if( pFilter->szCheckFlag[1] == '1' )
    {
        if( pFilter->szFilIP[0] )
        {
            if( strstr(u_pcfgs->host[0], pFilter->szFilIP) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->host[0][0] ) return(0);
        }
    }

    /* Ŀ· */
    if( pFilter->szCheckFlag[2] == '1' )
    {
        if( pFilter->szFilDstPath[0] )
        {
            if( strstr(u_pcfgs->dst_path, pFilter->szFilDstPath) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->dst_path[0] ) return(0);
        }
    }

    /*  */
    if( pFilter->szCheckFlag[3] == '1' )
    {
        if( pFilter->szFilAnalyzer[0] )
        {
            if( strstr(u_pcfgs->file_analyzer, pFilter->szFilAnalyzer) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->file_analyzer[0] ) return(0);
        }
    }

    /* ſ */
    if( pFilter->szCheckFlag[4] == '1' )
    {
        if( u_pcfgs->seq_ctrl != pFilter->iFilSeqCtrl ) return(0);
    }

    /*  */
    if( pFilter->szCheckFlag[5] == '1' )
    {
        if( toupper(u_pcfgs->optype) != pFilter->cFilOperType ) return(0);
    }

    /* ɼ */
    if( pFilter->szCheckFlag[9] == '1' )
    {
        if( pFilter->szFilNo[0] )
        {
            if( strstr(u_pcfgs->no, pFilter->szFilNo) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->no[0] ) return(0);
        }
    }

    /* Դ· */
    if( pFilter->szCheckFlag[10] == '1' )
    {
        if( pFilter->szFilSrcPath[0] )
        {
            if( strstr(u_pcfgs->src_path, pFilter->szFilSrcPath) == NULL ) return(0);
        }
        else
        {
            if( u_pcfgs->src_path[0] ) return(0);
        }
    }

    return(1);
}

int f_batfilter(void)
{
    int   i, b,
          iMatchNum = 0,                /* ϹĿ */
          iNum = 0;                     /*  */

    char *p,
          desc[65];

    static char buf1[1024];

    BATFILTER   sFilter;                /* ṹ */

    t_pzftp = f_conn_zshm(u_cportkey, 0);

    if( t_pzftp == NULL )
    {
        GC_sendecode(E_NOTRUN);
        return(0);
    }

    memset(&sFilter, 0, sizeof(sFilter));

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        if( u_TAGs[i].bSet == 0 ) continue;

        switch( u_TAGs[i].tag )
        {
        case TAG_DESCRIPTION:           /* Ϣ */

            sFilter.szCheckFlag[0] = '1';
            strcpy(sFilter.szFilDesc, u_TAGs[i].pv);
            break;

        case TAG_HOSTIP1:               /* IP */

            sFilter.szCheckFlag[1] = '1';
            strcpy(sFilter.szFilIP, u_TAGs[i].pv);
            break;

        case TAG_NO:                    /* ɼ */

            sFilter.szCheckFlag[9] = '1';
            strcpy(sFilter.szFilNo, u_TAGs[i].pv);
            break;

        case TAG_SOURCE_PATH:           /* Դ· */

            sFilter.szCheckFlag[10] = '1';
            strcpy(sFilter.szFilSrcPath, u_TAGs[i].pv);
            break;

        case TAG_DEST_PATH:             /* Ŀ· */

            sFilter.szCheckFlag[2] = '1';
            strcpy(sFilter.szFilDstPath, u_TAGs[i].pv);
            break;

        case TAG_FILE_ANALYZER:         /* ļ */

            sFilter.szCheckFlag[3] = '1';
            strcpy(sFilter.szFilAnalyzer, u_TAGs[i].pv);
            break;

        case TAG_SEQUENCE_CONTROL:      /* Ƿſ */

            sFilter.szCheckFlag[4] = '1';
            sFilter.iFilSeqCtrl = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;

        case TAG_OPERATION_TYPE:        /*  */

            sFilter.szCheckFlag[5] = '1';
            sFilter.iFilOperType = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;
        }
    }

    /* ת */
    sFilter.cFilOperType = 0;

    if( sFilter.iFilOperType == 0 ) sFilter.cFilOperType = SM_FTPGET;
    else if( sFilter.iFilOperType == 1 ) sFilter.cFilOperType = SM_FTPPUT;
    else if( sFilter.iFilOperType == 2 ) sFilter.cFilOperType = SM_FTPNOKIA;
    else if( sFilter.iFilOperType == 3 ) sFilter.cFilOperType = SM_FTAM;
    else if( sFilter.iFilOperType == 4 ) sFilter.cFilOperType = SM_SHELLPUT;

z_logv(g_logfile, "Flag=%s", sFilter.szCheckFlag);

    /* ɹ */
    GC_setpheadn(g_okcode, 3);

    /* ͳƷĿ */
    iMatchNum = 0;

    for( i = 0, u_pcfgs = u_cfgs; i < MAXN_Z; u_pcfgs++, i++ )
    {
        if( u_pcfgs->no[0] == 0 ) continue;
        if( f_filter(&sFilter) == 0 ) continue;
        iMatchNum ++;
    }

    sprintf(buf1, "%d", iMatchNum);
    GC_setpheadn(buf1, 5);

    /* ˷ļ¼ */
    iNum = 0;

    p = u_cinfo;
    *p = 0;

    for( i = 0, u_pruns = u_runs, u_pcfgs = u_cfgs; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
    {
        if( u_pcfgs->no[0] == 0 ) continue;
        if( f_filter(&sFilter) == 0 ) continue;

        iNum ++;

        /* Ϣ */
        b = z_chi_nohalf(u_pcfgs->desc, 64);
        strncpy(desc, u_pcfgs->desc, b);
        desc[b] = 0;

        sprintf(buf1, "%s+%s+%s+%s+%s,%s+%s,%s+%s+%s+%s+%s+%d+%d+%d+%d\n",
            u_pruns->uname, u_pcfgs->no, "", desc,
            u_pcfgs->host[0], u_pcfgs->host[1],
            u_pcfgs->pass[0], u_pcfgs->pass[1],
            u_pcfgs->file_analyzer, u_pcfgs->src_fn_pattern,
            u_pcfgs->dst_path, u_pcfgs->dst_format,
            u_pcfgs->busyitv, u_pcfgs->freeitv,
            u_pcfgs->nofile_limit, u_pcfgs->extracopy);

        strcpy(p, buf1);
        p += strlen(buf1);
        *p = 0;

        if( iNum == iMatchNum )         /* һ */
        {
            break;
        }
        else if( iNum % BATCHNUM == 0 )
        {
            /* Ӧģı־ */
            GC_setpheadn("1", 4);
            GC_sendtext(u_cinfo);

            p = u_cinfo;
            *p = 0;
        }
    }

    /* Ͽӹڴṹ */
    f_disconn_zshm();

    /* Ӧ */
    GC_setpheadn("0", 4);
    GC_sendtext(u_cinfo);

    return(0);
}
