/************
 Ϣ
 ************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

/************
 ű
 ************/
int f_crtOnShell(char *pOnFile, char *pNo, char *pBelong, char *pCfgDir, char cOperType)
{
    FILE *fp;
    char  szPlug[65];

    /*  */
    if( cOperType == SM_FTAM )
        strcpy(szPlug, PROG_FTAM);
    else
        strcpy(szPlug, PROG_FTP);

    if( (fp = fopen(pOnFile, "w")) == NULL )
    {
        return(-1);
    }

    /* дű */
    fprintf(fp, "#!/bin/ksh\n");
    fprintf(fp, "CITY_CFGDIR=%s\n", pCfgDir);
    fprintf(fp, "%s -c ${CPCONFIG} -k1 -f %s -n %s -e ${CITY_CFGDIR}/%s%s\n",
        PROG_PLAT, szPlug, pNo, pBelong, CFGSUFFIX);

    fclose(fp);

    /* ļȨ */
    if( chmod(pOnFile, S_IRUSR | S_IWUSR | S_IXUSR | S_IRGRP | S_IROTH) < 0 )
    {
        return(-1);
    }

    return(0);
}

int f_cfgone(void)
{
    FILE *fp;

    int   i, b,
          iSeq;

    char *p,
          szDir[256],
          szCfgDir[256],        /* Ŀ¼ */
          szCfgFile[256],       /* ļ */
          szFsnFile[256],       /* ļ */
          szOnFile[256],        /* ű */

          szNo[17],             /* ɼ */
          szBelong[9],          /* ֹ˾ */
          szGatherMode[17],     /* ɼģʽ */
          szWarnMode[17],       /* 澯ģʽ */
          szOperType[2],        /*  */
          szDstPath[129],       /* Ŀ· */
          szSrcDelBak[2],       /* Դɾݱ־ */
          szSeqCtrl[2],         /* Ƿϸſ */
          szSeqScope[34],       /* ŷΧ */
          szSeqCurr[17],        /* ǰ */

          szIP1[17],            /* IPû */
          szIP2[17],
          szUser1[17],
          szUser2[17],

          szIsEncry[2],         /* Ƿ */
          szPass1[17],
          szPass2[17],
          szPassEn1[33],
          szPassEn2[33],

          szValue[64],
          szBuf[128];

    static char szCmd[1024];

    struct stat    statbuf;

    uid_t  uid1;                /* ֹ˾ID */
    gid_t  gid1;

    szBelong[0] = 0;
    szFsnFile[0] = 0;
    szOnFile[0] = 0;
    szIsEncry[0] = 0;
    szSeqCtrl[0] = 0;
    szSeqCurr[0] = 0;
    szSeqScope[0] = 0;
    szDstPath[0] = 0;

    memset(szWarnMode, 0, sizeof(szWarnMode));
    memset(szGatherMode, '0', sizeof(szGatherMode));
    szGatherMode[sizeof(szGatherMode) - 1] = 0;

/* ----------------------------------------------------------------------- */
    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        switch( u_TAGs[i].tag )
        {
        case TAG_OPERATION_TYPE:    /*  */

            if( *(u_TAGs[i].pv) == '0' ) szOperType[0] = SM_FTPGET;
            else if( *(u_TAGs[i].pv) == '1' ) szOperType[0] = SM_FTPPUT;
            else if( *(u_TAGs[i].pv) == '2' ) szOperType[0] = SM_FTPNOKIA;
            else if( *(u_TAGs[i].pv) == '3' ) szOperType[0] = SM_FTAM;
            else if( *(u_TAGs[i].pv) == '4' ) szOperType[0] = SM_SHELLPUT;
            else return(-1);

            szOperType[1] = 0;
            break;

        case TAG_GATHER_MODE:       /* ɼģʽ */

            if( u_TAGs[i].pv[0] == '1' ) szGatherMode[0] = SM_NOLATEST;
            else if( u_TAGs[i].pv[0] != '0' ) return(-1);

            if( u_TAGs[i].pv[1] == '1' ) szGatherMode[1] = SM_NOTMPNAME;
            else if( u_TAGs[i].pv[1] != '0' ) return(-1);

            if( u_TAGs[i].pv[2] == '1' ) szGatherMode[2] = SM_TIMESUFFIX;
            else if( u_TAGs[i].pv[2] != '0' ) return(-1);

            szGatherMode[3] = 0;
            break;

        case TAG_ENCRYPTION:        /* Ƿ */

            strcpy(szIsEncry, u_TAGs[i].pv);
            break;

        case TAG_SOURCE_MOVEDEL:    /* Դɾ־ */

            if( *(u_TAGs[i].pv) == '0' ) szSrcDelBak[0] = BF_DELETE + '0';
            else if( *(u_TAGs[i].pv) == '1' ) szSrcDelBak[0] = BF_MOVE + '0';
            else if( *(u_TAGs[i].pv) == '2' ) szSrcDelBak[0] = BF_NONE + '0';
            else return(-1);

            szSrcDelBak[1] = 0;
            break;

        case TAG_DEST_PATH:         /* Ŀ· */

            strcpy(szDstPath, u_TAGs[i].pv);
            break;

        case TAG_BELONG:            /* ֹ˾ */

            strcpy(szBelong, u_TAGs[i].pv);
            break;

        case TAG_NO:                /* ɼ */

            strcpy(szNo, u_TAGs[i].pv);
            break;

        case TAG_HOSTIP1:           /* IP */

            strcpy(szIP1, u_TAGs[i].pv);
            break;

        case TAG_HOSTIP2:           /* IP */

            strcpy(szIP2, u_TAGs[i].pv);
            break;

        case TAG_USER1:             /* û */

            strcpy(szUser1, u_TAGs[i].pv);
            break;

        case TAG_USER2:             /* û */

            strcpy(szUser2, u_TAGs[i].pv);
            break;

        case TAG_PASSWORD1:         /*  */

            strcpy(szPass1, u_TAGs[i].pv);
            break;

        case TAG_PASSWORD2:         /*  */

            strcpy(szPass2, u_TAGs[i].pv);
            break;

        case TAG_SEQUENCE_SCOPE:    /* ŷΧ */

            strcpy(szSeqScope, u_TAGs[i].pv);
            break;

        case TAG_SEQUENCE_CONTROL:  /* ſ */

            strcpy(szSeqCtrl, u_TAGs[i].pv);
            break;

        case TAG_SEQCURR:           /* ǰ */

            strcpy(szSeqCurr, u_TAGs[i].pv);
            break;

        case TAG_WARN_MODE:         /* 澯ģʽ */

            strcpy(szWarnMode, u_TAGs[i].pv);
            break;
        }
    }

/* ----------------------------------------------------------------------- */
    /* ȡֹ˾Ŀ¼ */
    b = z_readini(CITYS_CFG, SEG_DIRCFG, szBelong, szCfgDir, sizeof(szCfgDir) - 1, 0);

    if( b )
    {
        GC_sendecode(E_LOGONDENY);
        return(1);
    }

    /* · */
    if( access(szCfgDir, R_OK) )
    {
        GC_sendecode(E_BELONG);
        return(2);
    }

/* ----------------------------------------------------------------------- */
    /* TAG */
    if( szIsEncry[0] == '1' )
    {
        memset(szPassEn1, 0, sizeof(szPassEn1));
        memset(szPassEn2, 0, sizeof(szPassEn2));

        f_pass_encry(szPass1, szPassEn1);
        f_pass_encry(szPass2, szPassEn2);

        sprintf(szBuf, "%s%s%s", szPassEn1, SM_HYPHEN, szPassEn2);
    }
    else
        sprintf(szBuf, "%s%s%s", szPass1, SM_HYPHEN, szPass2);

    if( f_setTAG(TAG_PASSWORD_PAIR, szBuf) < 0 ) return(-1);

    /* IP */
    sprintf(szBuf, "%s%s%s", szIP1, SM_HYPHEN, szIP2);
    if( f_setTAG(TAG_HOSTIP_PAIR, szBuf) < 0 ) return(-1);

    /* û */
    sprintf(szBuf, "%s%s%s", szUser1, SM_HYPHEN, szUser2);
    if( f_setTAG(TAG_USER_PAIR, szBuf) < 0 ) return(-1);

    /* ɼģʽ */
    if( f_setTAG(TAG_GATHER_MODE, szGatherMode) < 0 ) return(-1);

    /*  */
    if( f_setTAG(TAG_OPERATION_TYPE, szOperType) < 0 ) return(-1);

    /* Դɾ־ */
    if( f_setTAG(TAG_SOURCE_MOVEDEL, szSrcDelBak) < 0 ) return(-1);

/* ----------------------------------------------------------------------- */
    /* дļ */
    snprintf(szCfgFile, sizeof(szCfgFile), "%s/%s%s", szCfgDir, szNo, CFGSUFFIX);

    if( (fp = fopen(szCfgFile, "w")) == NULL )
    {
        GC_sendecode(E_FILE);
        return(3);
    }

    fprintf(fp, "[%s]\n\n", szNo);

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;
        if( u_TAGs[i].group != TAGGRP_ONE ) continue;

        fprintf(fp, "%s=%s\n", u_TAGs[i].key, u_TAGs[i].pv);
    }
    fclose(fp);

/* ----------------------------------------------------------------------- */
    switch( u_pkthead.tc )
    {
    case TC_ACFGONE:    /* ɼ */

        /* ļ */
        if( szSeqCtrl[0] == '1' || szWarnMode[WF_SEQBREAK - 1] == '1' )
        {
            iSeq = -1;

            if( szSeqCtrl[0] == '1' )
            {
                iSeq = (int) strtol(szSeqCurr, (char **)NULL, 10);

                /* ųȣf_fsn_write()Ҫ */
                u_zcfg.seq_length = (strlen(szSeqScope) - 1) / 2;
            }

            /* ȡֹ˾Ŀ¼ */
            b = z_readini(CITYS_CFG, SEG_DIRFSN, szBelong, szDir, sizeof(szDir) - 1, 0);

            if( b )
            {
                GC_sendecode(E_FILE);
                return(1);
            }

            /* ɼļ */
            snprintf(szFsnFile, sizeof(szFsnFile), "%s/%s%s", szDir, szNo, FSNSUFFIX);

            if( f_fsn_write(szFsnFile, iSeq) < 0 )
            {
                GC_sendecode(E_FILE);
                return(3);
            }
        }

        /* ȨϢ */
        if( f_addAuth(szNo, szBelong) < 0 )
        {
            GC_sendecode(E_FILE);
            return(1);
        }

        /* ȡֹ˾ĽűĿ¼ */
        if( z_readini(CITYS_CFG, SEG_DIRBIN, szBelong, szDir, sizeof(szDir) - 1, 0) )
        {
            break;
        }

        /* ű */
        sprintf(szOnFile, "%s/%s%s", szDir, ONPREFIX, szNo);

        if( stat(szOnFile, &statbuf) < 0 && f_crtOnShell(szOnFile, szNo, szBelong, szCfgDir, szOperType[0]) < 0 )
        {
            GC_sendecode(E_FILE);
            return(1);
        }

        break;
    }

/* ----------------------------------------------------------------------- */
    /* ȡֹ˾ID */
    b = z_readini(CITYS_CFG, SEG_LOGONUSERS, szBelong, szBuf, sizeof(szBuf) - 1, 0);

    if( b )
    {
        GC_sendecode(E_FILE);
        return(1);
    }

    /* ļȨ */
    p = szBuf;

    z_get_fieldv(&p, szValue, NULL, sizeof(szValue) - 1, ",");
    uid1 = strtol(szValue, (char **)NULL, 10);

    z_get_fieldv(&p, szValue, NULL, sizeof(szValue) - 1, ",");
    gid1 = strtol(szValue, (char **)NULL, 10);

    if( chown(szCfgFile, uid1, gid1) < 0 )
    {
        GC_sendecode(E_FILE);
        return(1);
    }

    if( szFsnFile[0] && chown(szFsnFile, uid1, gid1) < 0 )
    {
        GC_sendecode(E_FILE);
        return(1);
    }

    if( szOnFile[0] && chown(szOnFile, uid1, gid1) < 0 )
    {
        GC_sendecode(E_FILE);
        return(1);
    }

/* ----------------------------------------------------------------------- */
    /* ԶĿ· */
    if( szOperType[0] != SM_FTPPUT &&
        szOperType[0] != SM_SHELLPUT &&
        strchr(szDstPath, SM_PATH_DATE) == NULL )
    {
        if( stat(szDstPath, &statbuf) < 0 )
        {
            /* ȡĿ¼ */
            if( z_getkeyv(g_cfgfile, "NEWDIRGID", szValue, sizeof(szValue) - 1) )
            {
                GC_sendecode(E_FILE);
                return(3);
            }
            gid1 = strtol(szValue, (char **)NULL, 10);

            if( mkdir(szDstPath, NEWDIRMODE) < 0 )
            {
                GC_sendecode(E_FILE);
                return(3);
            }
            if( chown(szDstPath, uid1, gid1) < 0 )
            {
                GC_sendecode(E_FILE);
                return(1);
            }
            if( chmod(szDstPath, NEWDIRMODE | S_ISGID) < 0 )
            {
                GC_sendecode(E_FILE);
                return(3);
            }
        }
    }

    /* ˢò */
    if( u_pkthead.tc == TC_WCFGONE )
    {
        sprintf(szCmd, "%s -c %s -n %s -R", u_szPlatHelp, u_szPlatCfg, szNo);
        z_logv(g_logfile, szCmd);

        system(szCmd);
    }

    /* Ӧ */
    GC_sendecode(g_okcode);

    return(0);
}
