/********************
 ͻ˵Ϣ
 ********************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvdef.h"

CTAGS   u_TAGs[MAXN_TAG] =
{
    /* ֹ˾ */
    {TAG_BELONG,         "", 8},
    /* ɼ */
    {TAG_NO,             "", 16},
    /* IP */
    {TAG_HOSTIP2,        "", 15, 201},
    /* û */
    {TAG_USER2,          "", 16, 202},
    /*  */
    {TAG_PASSWORD2,      "", 16, 203},
    /* С */
    {TAG_SEQMIN,         "", 16, 204},
    /*  */
    {TAG_SEQMAX,         "", 16, 205},
    /* ǰ */
    {TAG_SEQCURR,        "", 16, 206},
    /* Դļ() */
    {TAG_SOURCENAME,     "", 128},
    /* ı */
    {TAG_LONG,           "", 9999},

/* ع */
    /* Ƿ澯 */
    {TAG_MONWARNNOT,     "", 2},
    /* ״̬Ƿ */
    {TAG_MONSTATOK,      "", 2},
    /* ʼ */
    {TAG_MONSTARTSEQ,    "", 10},
    /* ɼ */
    {TAG_MONSHOWROWS,    "", 10},

/* ӦϢ */
    /* ־· */
    {TAG_LOGPATH,        "[DIRLOG]",      255, 100, TAGGRP_CITY_REP},
    /* · */
    {TAG_CFGPATH,        "[DIRCFG]",      255, 101, TAGGRP_CITY_REP},
    /* · */
    {TAG_FSNPATH,        "[DIRFSN]",      255, 102, TAGGRP_CITY_REP},
    /* ɼĿ */
    {TAG_NUMGATHER,      "MAXSCPNUM",     10,  104, TAGGRP_PLAT_REP},
    /* ־ļĿ */
    {TAG_NUMLOG,         "LOGLOOPS",      10,  105, TAGGRP_PLAT_REP},

/* ֹ˾ȫ */
    /* Ÿ澯 */
    {TAG_CITYSMSNUMBERS, "CITY_SMS_NUMBERS",  255, 106, TAGGRP_CITY},
    /* Ÿ澯 */
    {TAG_DIALNUMBERS,    "CITY_DIAL_NUMBERS", 64,  107, TAGGRP_CITY},

/* ƽ̨ȫ */
    /* ʡ˾Ÿ澯 */
    {TAG_PROSMSNUMBERS,  "PROVINCE_SMS_NUMBERS", 127, 108,  TAGGRP_PLAT},
    /* æʱʱ */
    {TAG_PLAT_BUSY_TIME, "BUSY_TIME",            11,  109,  TAGGRP_PLAT},
    /* æʱ澯ʱ */
    {TAG_BUSYNOFILET,    "BUSYNOFILET",          10,  110,  TAGGRP_PLAT},
    /* ʱ澯ʱ */
    {TAG_FREENOFILET,    "FREENOFILET",          10,  111,  TAGGRP_PLAT},
    /* ʡ˾澯 */
    {TAG_PROWARNITV,     "PROVINCE_WARNITV",     10,  112,  TAGGRP_PLAT},
    /* ֹ˾澯 */
    {TAG_CITYWARNITV,    "CITY_WARNITV",         10,  113,  TAGGRP_PLAT},
    /* ʱ澯ʱ */
    /* {TAG_HDTIMELIMIT,    "HDTIMELIMIT",          10,  114,  TAGGRP_PLAT}, */
    /* IP */
    {TAG_HOSTIP1,        "STANDBY_HOST",         15,  115,  TAGGRP_PLAT},
    /* û */
    {TAG_USER1,          "STANDBY_USER",         16,  116,  TAGGRP_PLAT},
    /*  */
    {TAG_PASSWORD1,      "STANDBY_PASS",         16,  117,  TAGGRP_PLAT},
    /* Ƿ */
    {TAG_RZENCRYPTION,   "STANDBY_ENCRYPTION",   1,   1030, TAGGRP_PLAT},
    /* ֲʱʱ */
    {TAG_RZFTP_TIMEOUT,  "STANDBY_TIMEOUT",      10,  119,  TAGGRP_PLAT},
    /* Ϣű */
    {TAG_NIDNORM_SHELL,  "NIDNORM_SHELL",        64,  130,  TAGGRP_PLAT},
    /* ܸ澯Ϣű */
    {TAG_NIDWARN_SHELL,  "NIDWARN_SHELL",        64,  131,  TAGGRP_PLAT},
    /* ϵͳϢű */
    {TAG_SYSINFO_SHELL,  "SYSINFO_SHELL",        64,  132,  TAGGRP_PLAT},

/* ɼ */
    /* ɼ */
    {TAG_DESCRIPTION,        "DESCRIPTION",          64,  301,  TAGGRP_ONE},
    /*  */
    {TAG_OPERATION_TYPE,     "OPERATION_TYPE",       2,   302,  TAGGRP_ONE},
    /* ɼģʽ */
    {TAG_GATHER_MODE,        "GATHER_MODE",          16,  303,  TAGGRP_ONE},
    /* IP */
    {TAG_HOSTIP_PAIR,        "HOSTIP_PAIR",          33,  304,  TAGGRP_ONE},
    /* û */
    {TAG_USER_PAIR,          "USER_PAIR",            33,  305,  TAGGRP_ONE},
    /*  */
    {TAG_PASSWORD_PAIR,      "PASSWORD_PAIR",        65,  306,  TAGGRP_ONE},
    /* Ƿ */
    {TAG_ENCRYPTION,         "ENCRYPTION",           1,   1002, TAGGRP_ONE},
    /* Դƥģʽ */
    {TAG_SOURCE_PATTERN,     "SOURCE_PATTERN",       64,  308,  TAGGRP_ONE},
    /* Դʽ */
    {TAG_SOURCE_NAME_FILTER, "SOURCE_NAME_FILTER",   64,  309,  TAGGRP_ONE},
    /* Դɾ־ */
    {TAG_SOURCE_MOVEDEL,     "SOURCE_MOVEDEL",       1,   310,  TAGGRP_ONE},
    /* Դ· */
    {TAG_SOURCE_PATH,        "SOURCE_PATH",          128, 311,  TAGGRP_ONE},
    /* Դ· */
    {TAG_SOURCE_BACKUP_PATH, "SOURCE_BACKUP_PATH",   128, 312,  TAGGRP_ONE},
    /* Ŀ· */
    {TAG_DEST_PATH,          "DEST_PATH",            128, 313,  TAGGRP_ONE},
    /* Ŀתʽ */
    {TAG_DEST_NAME_FORMAT,   "DEST_NAME_FORMAT",     64,  314,  TAGGRP_ONE},
    /* æʱʱ */
    {TAG_BUSY_TIME,          "BUSY_TIME",            11,  315,  TAGGRP_ONE},
    /* æʱɼ */
    {TAG_BUSY_INTERVAL,      "BUSY_INTERVAL",        10,  316,  TAGGRP_ONE},
    /* ʱɼ */
    {TAG_FREE_INTERVAL,      "FREE_INTERVAL",        10,  317,  TAGGRP_ONE},
    /* ļ澯ʱ */
    {TAG_NOFILE_LIMIT,       "NOFILE_LIMIT",         10,  318,  TAGGRP_ONE},
    /* ʱʱ */
    {TAG_FTP_TIMEOUT,        "FTP_TIMEOUT",          10,  319,  TAGGRP_ONE},
    /*  */
    {TAG_FILE_ANALYZER,      "FILE_ANALYZER",        64,  320,  TAGGRP_ONE},
    /* Ƿſ */
    {TAG_SEQUENCE_CONTROL,   "SEQUENCE_CONTROL",     1,   1003, TAGGRP_ONE},
    /* ŷΧ */
    {TAG_SEQUENCE_SCOPE,     "SEQUENCE_SCOPE",       33,  322,  TAGGRP_ONE},
    /* 澯ģʽtag Ԥ161006-1021 */
    {TAG_WARN_MODE,          "WARN_MODE",            16,  1006, TAGGRP_ONE},
    /* ¼С */
    {TAG_RECORD_SIZE,        "RECORD_SIZE",          10,  324,  TAGGRP_ONE},
    /* [С] */
    {TAG_SIZE_COL,           "SIZE_COL",             2,   325,  TAGGRP_ONE},
    /* Ᵽ */
    {TAG_EXTRACOPY,          "EXTRACOPY",            2,   326,  TAGGRP_ONE},
    /* FTP ϵ־ */
    {TAG_FTP_RESUME,         "FTP_RESUME",           1,   1004, TAGGRP_ONE},
    /* FTP ģʽ־ */
    {TAG_FTP_PASSIVE,        "FTP_PASSIVE",          1,   1005, TAGGRP_ONE},
    /* Ƿ */
    {TAG_STATUS,             "STATUS",               1,   1001, TAGGRP_ONE},
    /* FTP ˿ */
    {TAG_FTPPORT,            "FTPPORT",              5,   327,  TAGGRP_ONE},
    /* ʧܳԴ */
    {TAG_RETRY_TIMES,        "RETRY_TIMES",          2,   328,  TAGGRP_ONE},
    /* ʧܳԼ */
    {TAG_RETRY_ITV,          "RETRY_INTERVAL",       10,  329,  TAGGRP_ONE},
    /* ӽű */
    {TAG_ATTACH_SHELL,       "ATTACH_FILE",          64,  330,  TAGGRP_ONE},
    /* ɹű */
    {TAG_OK_SHELL,           "OK_SHELL",             64,  331,  TAGGRP_ONE},
    /* ʧܽű */
    {TAG_FAIL_SHELL,         "FAIL_SHELL",           64,  332,  TAGGRP_ONE},
    /* Զ̱ݳԴ */
    {TAG_RMT_BAK_TIMES,      "REMOTE_BAK_TIMES",     2,   333,  TAGGRP_ONE},
    /* ǰ׼ű */
    {TAG_PRE_SHELL,          "PREPARE_SHELL",        64,  334,  TAGGRP_ONE},
    /* ļСű */
    {TAG_SIZE_SHELL,         "SIZE_SHELL",           64,  335,  TAGGRP_ONE},
    /* ű */
    {TAG_DATA_SHELL,         "DATA_SHELL",           64,  336,  TAGGRP_ONE},
    /* ű */
    {TAG_MOVE_SHELL,         "RENAME_SHELL",         64,  337,  TAGGRP_ONE},
    /*  */
    {0,                      "",                     0                    }
};

PKTHEAD  u_pkthead;                       /* ͷ */
char     u_cinfo[ 64 * 1000 ];            /*  */
key_t    u_cportkey;                      /* ɼƽ̨key */

char     u_szPlatExe[256],                /* ɼƽִ̨г */
         u_szPlatHelp[256],               /* ɼƽ̨ */
         u_szPlatCfg[256],                /* ɼƽ̨ļ */
         u_szPno[16];                     /*  */

int f_dispense(char *pno)
{
    int i, r, n;

    int f_logon(void),                    /*  */
        f_mon(void),
        f_onoff_one(void),
        f_warn(void),
        f_cfgone(void),
        f_onecfg(void),
        f_regtest(void),
        f_cfgcity(void),
        f_cfgplat(void),
        f_platstat(void),
        f_platstop(void),
        f_platstart(void),
        f_logqry(void),
        f_seqadj(void),
        f_batfilter(void),
        f_batupdate(void),
        f_statget(void),
        f_authonly(void),
        f_sysinfo(void),
        f_wrfile(void);

    static struct code_func
    {
        char           code;              /* ״ */
        int          (*func)();           /*  */
    } funcs[] =
    {
        {TC_LOGON,     f_logon      },    /* ¼ */
        {TC_MON,       f_mon        },    /* Ļ */
        {TC_STOP,      f_onoff_one  },    /* ֹͣ */
        {TC_START,     f_onoff_one  },    /*  */
        {TC_WARNON,    f_warn       },    /* 򿪸澯 */
        {TC_WARNOFF,   f_warn       },    /* رո澯 */
        {TC_ACFGONE,   f_cfgone     },    /* ɼ */
        {TC_WCFGONE,   f_cfgone     },    /*  */
        {TC_RCFGONE,   f_onecfg     },    /* ȡ */
        {TC_REGTEST,   f_regtest    },    /* ʽƥ */
        {TC_NAMETEST,  f_regtest    },    /* Ŀתʽ */
        {TC_CFGCITY,   f_cfgcity    },    /* ֹ˾ȫ */
        {TC_RCFGCITY,  f_cfgcity    },    /* ȡֹ˾ȫ */
        {TC_CFGPLAT,   f_cfgplat    },    /* ƽ̨ȫ */
        {TC_RCFGPLAT,  f_cfgplat    },    /* ȡƽ̨ȫ */
        {TC_RSEQADJ,   f_seqadj     },    /* ȡ */
        {TC_WSEQADJ,   f_seqadj     },    /*  */
        {TC_STATPLAT,  f_platstat   },    /* ƽ̨״̬ */
        {TC_LOGQRY,    f_logqry     },    /* ־ѯ */
        {TC_STOPPLAT,  f_platstop   },    /* ֹͣƽ̨ */
        {TC_STARTPLAT, f_platstart  },    /* ƽ̨ */
        {TC_BATFILTER, f_batfilter  },    /* ޸. */
        {TC_BATUPDATE, f_batupdate  },    /* ޸.ִ */
        {TC_STATGET,   f_statget    },    /* ˢ״̬ */
        {TC_AUTHONLY,  f_authonly   },    /* Ȩ */
        {TC_SYSINFO,   f_sysinfo    },    /* ѯϵͳϢ */
        {TC_READFILE,  f_wrfile     },    /* ȡļ */
        {TC_WRITEFILE, f_wrfile     }     /* дļ */
    };

    r = 0;
    n = sizeof(funcs) / sizeof(struct code_func);

    strcpy(u_szPno, pno);

    /* ¼ */
    z_logv(g_logfile, "<%-15s:%s", g_clientip, g_reqinfo);

    /*  */
    memset(&u_pkthead, 0, sizeof(PKTHEAD));

    GC_getpheadn((&u_pkthead.tc), 2);
    GC_getpheadn(u_pkthead.user, 4);
    GC_getpheadn(u_pkthead.uid, 5);
    z_rtrim(u_pkthead.user);
    z_rtrim(u_pkthead.uid);

    z_logv(g_logfile, u_pkthead.user);

    /* ҵ룬ӦĴ */
    for( i = 0; i < n; i++ )
    {
        if( u_pkthead.tc == funcs[i].code )
        {
            /* ɼƽ̨ļ */
            if( u_szPlatCfg[0] == 0 )
            {
                if( z_readini(CITYS_CFG, SEG_PLATFORM, "CFG", u_szPlatCfg, sizeof(u_szPlatCfg) - 1, 0) )
                {
                    GC_sendecode(E_FILE);
                    return(1);
                }
            }

            /* ɼƽִ̨г */
            if( u_szPlatExe[0] == 0 )
            {
                if( z_readini(CITYS_CFG, SEG_PLATFORM, "EXE", u_szPlatExe, sizeof(u_szPlatExe) - 1, 0) )
                {
                    GC_sendecode(E_FILE);
                    return(1);
                }
            }

            /* ɼƽ̨ */
            if( u_szPlatHelp[0] == 0 )
            {
                if( z_readini(CITYS_CFG, SEG_PLATFORM, "HELP", u_szPlatHelp, sizeof(u_szPlatHelp) - 1, 0) )
                {
                    GC_sendecode(E_FILE);
                    return(1);
                }
            }

            /* һÿTAG */
            if( f_unpackTLV(g_reqinfo + g_phlen, g_iplen - g_phlen) < 0 ) return(-1);

            r = (int) (funcs[i].func)();
            break;
        }
    }

    /* ¼Ӧ */
    n = z_chi_nohalf(g_repinfo, 64);
    g_repinfo[n] = 0;

    z_logv(g_logfile, ">%-15s:|%s|", g_clientip, g_repinfo);

    return(r);
}
