/********
 ŵ
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

int f_seqadj(void)
{
    int   i, b, iSeq = 0;

    char *p,
          szNo[17],             /* ɼ */
          szBelong[21],         /* ֹ˾ */

          szDir[256],
          szFile[256],

          szSeqScope[34],
          szNewSeq[17],
          szSeqMin[17],
          szSeqMax[17],
          szStr[8];

    static char szCmd[1024];

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        switch( u_TAGs[i].tag )
        {
        case TAG_BELONG:            /* ֹ˾ */

            strcpy(szBelong, u_TAGs[i].pv);
            break;

        case TAG_NO:                /* ɼ */

            strcpy(szNo, u_TAGs[i].pv);
            break;

        case TAG_SEQCURR:           /*  */

            strcpy(szNewSeq, u_TAGs[i].pv);
            break;
        }
    }

    if( u_pkthead.tc == TC_RSEQADJ )
    {
        /* ȡֹ˾Ŀ¼ */
        b = z_readini(CITYS_CFG, SEG_DIRCFG, szBelong, szDir, sizeof(szDir) - 1, 0);

        if( b )
        {
            GC_sendecode(E_LOGONDENY);
            return(1);
        }

        /* · */
        if( access(szDir, R_OK) )
        {
            GC_sendecode(E_BELONG);
            return(2);
        }

        /* ɼļ */
        snprintf(szFile, sizeof(szFile), "%s/%s%s", szDir, szNo, CFGSUFFIX);

        /* ŷΧ */
        if( z_getkeyv(szFile, "SEQUENCE_SCOPE", szSeqScope, sizeof(szSeqScope) - 1) )
        {
            GC_sendecode(E_FILE);
            return(1);
        }

        p = szSeqScope;
        szStr[0] = SM_SEQHYPHEN; szStr[1] = 0;

        z_get_fieldv(&p, szSeqMin, NULL, sizeof(szSeqMin) - 1, szStr);
        z_get_fieldv(&p, szSeqMax, NULL, sizeof(szSeqMax) - 1, szStr);

        p = u_cinfo;
        *p = 0;

        // С
        f_packTLV(&p, szSeqMin, TAG_SEQMIN);

        // 
        f_packTLV(&p, szSeqMax, TAG_SEQMAX);

        /* ȡֹ˾Ŀ¼ */
        b = z_readini(CITYS_CFG, SEG_DIRFSN, szBelong, szDir, sizeof(szDir) - 1, 0);

        if( b )
        {
            GC_sendecode(E_FILE);
            return(1);
        }

        /* ɼļ */
        snprintf(szFile, sizeof(szFile), "%s/%s%s", szDir, szNo, FSNSUFFIX);

        /* ǰ */
        if( f_fsn_read(szFile, &iSeq) == 0 )
        {
            sprintf(szSeqMin, "%d", iSeq);
            f_packTLV(&p, szSeqMin, TAG_SEQCURR);
        }

        *p = 0;
        GC_setpheadn(g_okcode, 3);
        GC_sendtext(u_cinfo);
    }
    else
    {
        sprintf(szCmd, "%s -c %s -n %s -u %s", u_szPlatHelp, u_szPlatCfg, szNo, szNewSeq);
        z_logv(g_logfile, szCmd);

        b = system(szCmd);
        GC_sendecode(g_okcode);
    }

    return(b);
}
