

#ifndef __SPICE_CLIENT_USBREDIR_CHANNEL_H__
#define __SPICE_CLIENT_USBREDIR_CHANNEL_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif

#include "spice-client.h"

G_BEGIN_DECLS

#define SPICE_TYPE_USBREDIR_CHANNEL            (spice_usbredir_channel_get_type())
#define SPICE_USBREDIR_CHANNEL(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), SPICE_TYPE_USBREDIR_CHANNEL, SpiceUsbredirChannel))
#define SPICE_USBREDIR_CHANNEL_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), SPICE_TYPE_USBREDIR_CHANNEL, SpiceUsbredirChannelClass))
#define SPICE_IS_USBREDIR_CHANNEL(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), SPICE_TYPE_USBREDIR_CHANNEL))
#define SPICE_IS_USBREDIR_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), SPICE_TYPE_USBREDIR_CHANNEL))
#define SPICE_USBREDIR_CHANNEL_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), SPICE_TYPE_USBREDIR_CHANNEL, SpiceUsbredirChannelClass))

typedef struct _SpiceUsbredirChannel SpiceUsbredirChannel;
typedef struct _SpiceUsbredirChannelClass SpiceUsbredirChannelClass;
typedef struct _SpiceUsbredirChannelPrivate SpiceUsbredirChannelPrivate;


struct _SpiceUsbredirChannel {
    SpiceChannel parent;

    
    SpiceUsbredirChannelPrivate *priv;
    
};


struct _SpiceUsbredirChannelClass {
    SpiceChannelClass parent_class;

    

    
    
};

GType spice_usbredir_channel_get_type(void);

G_END_DECLS

#endif 

