

#ifndef __SPICE_WEBDAV_CHANNEL_H__
#define __SPICE_WEBDAV_CHANNEL_H__

#if !defined(__SPICE_CLIENT_H_INSIDE__) && !defined(SPICE_COMPILATION)
#warning "Only <spice-client.h> can be included directly"
#endif

#include <gio/gio.h>
#include "spice-client.h"
#include "channel-port.h"

G_BEGIN_DECLS

#define SPICE_TYPE_WEBDAV_CHANNEL            (spice_webdav_channel_get_type())
#define SPICE_WEBDAV_CHANNEL(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), SPICE_TYPE_WEBDAV_CHANNEL, SpiceWebdavChannel))
#define SPICE_WEBDAV_CHANNEL_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), SPICE_TYPE_WEBDAV_CHANNEL, SpiceWebdavChannelClass))
#define SPICE_IS_WEBDAV_CHANNEL(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), SPICE_TYPE_WEBDAV_CHANNEL))
#define SPICE_IS_WEBDAV_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), SPICE_TYPE_WEBDAV_CHANNEL))
#define SPICE_WEBDAV_CHANNEL_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), SPICE_TYPE_WEBDAV_CHANNEL, SpiceWebdavChannelClass))

typedef struct _SpiceWebdavChannel SpiceWebdavChannel;
typedef struct _SpiceWebdavChannelClass SpiceWebdavChannelClass;
typedef struct _SpiceWebdavChannelPrivate SpiceWebdavChannelPrivate;


struct _SpiceWebdavChannel {
    SpicePortChannel parent;

    
    SpiceWebdavChannelPrivate *priv;
    
};


struct _SpiceWebdavChannelClass {
    SpicePortChannelClass parent_class;

    
    
};

GType spice_webdav_channel_get_type(void);

G_END_DECLS

#endif 

