/****************
 UAP ⺯
 ****************/
#ifndef _UAP_API_H
#define _UAP_API_H

#ifdef  __cplusplus
extern "C" {
#endif

/******************************
 ȡڴ桢źŵ
 ڲkey_t   --  KEY ֵ
 ֵ  -1ʧ  0ɹ
 ******************************/
int u_get_ipc(key_t aKey);

/****************
 Ͽӹڴ
 ****************/
void u_unget_ipc(void);

/************************************
 ȡӵϢ
 ڲconst char * -- ӵID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0ɹ
 ************************************/
int u_get_nodeinf(const char *pNodeID, char *pOutBuf);

/**********************************
 ִIP֤
 ڲconst char * -- ӵID
           const char * -- ֤IP
 ֵ  -1ʧ  0ܾ  1ͨ
 **********************************/
int u_do_ipauth(const char *pNodeID, const char *pIP);

/************************************
 ִû֤
 ڲconst char * -- ӵID
           const char * -- ֤û
           const char * -- ֤
 ֵ  -1ʧ  0ܾ  1ͨ
 ************************************/
int u_do_userauth(const char *pNodeID, const char *pUser, const char *pPass);

/************************************
 ȡҵϢ
 ڲconst char * -- ҵID
           const char * -- ID
           const char * -- ЭID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_busiinf(const char *pBusiID, const char *pChanID, const char *pProtID, char *pOutBuf);

/************************************
 ȡŶϢ
 ڲchar *       -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_h3inf(const char *pTel, char *pOutBuf);

/************************************
 ȡϢ
 ڲconst char * -- ID
           const char * -- ҵID
           const char * -- Դ
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_rcodeinf(const char *pChanID, const char *pBusiID, const char *pFrom, char *pOutBuf);

/************************************
 ȡƷӳϢ->
 ڲint          -- 
           const char * -- Ʒ
           const char * -- ɲƷID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_pmapO(int nRegion, const char *pProdTyp, const char *pOldPID, char *pOutBuf);

/************************************
 ȡƷӳϢ->
 ڲconst char * -- ƷID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_pmapN(const char *pProdID, char *pOutBuf);

/************************************
 ȡиϢ
 ڲint          -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_cutover(int nRegion, char *pOutBuf);

/**********************************
 õиӱ־
 ڲint          -- 
           int          -- ӱ־
 ֵ  -1ʧ  0޼¼  1ɹ
 **********************************/
int u_set_cutover(int nRegion, int nCutOver);

/************************************
 ȡӦ״̬Ϣ
 ڲint          -- 
           char *       -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_urge(int nRegion, const char *pChannel, char *pOutBuf);

/**********************************
 Ӧ״̬
 ڲint      -- 
           char *   -- 
           char *   -- Ӧ״̬
           char *   -- ״̬ʱ
 ֵ  -1ʧ  0޼¼  1ɹ
 **********************************/
int u_set_urge(int nRegion, const char *pChannel, const char *pUrge, const char *pTime);

#ifdef  __cplusplus
}
#endif

class CUapApi
{
public:
    static void setIPCKey(key_t aKey);
    static int  getIPC(key_t aKey);
    static void ungetIPC(void);

    static int getNodeInf(const char *pNodeID, char *pOutBuf);
    static int doIPAuth(const char *pNodeID, const char *pIP);
    static int doUserAuth(const char *pNodeID, const char *pUser, const char *pPass);
    static int getBusiInf(const char *pNodeID, const char *pChanID, const char *pProtID, char *pOutBuf);
    static int getH3Inf(const char *pTel, char *pOutBuf);
    static int getRCodeInf(const char *pChanID, const char *pBusiID, const char *pFrom, char *pOutBuf);
    static int getPMapO(int nRegion, const char *pProdTyp, const char *pOldPID, char *pOutBuf);
    static int getPMapN(const char *pProdID, char *pOutBuf);
    static int getCutOver(int nRegion, char *pOutBuf);
    static int setCutOver(int nRegion, int nCutOver);
    static int getUrge(int nRegion, const char *pChannel, char *pOutBuf);
    static int setUrge(int nRegion, const char *pChannel, const char *pUrge, const char *pTime);

private:
    static key_t    mKey;
};

#endif
