/****************
 ɼģ鹫ú
 ****************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include "gcps.h"
#include "z.h"
#include "zvar.h"

#define   W_ID_DELAY    "A901"      // 澯ID-ӳ

/********************************************
 ¼ʧʱִ
 ڲchar *ppat    Դļģʽ
           char *flist   бļ
           char *zout    ļ
           char *outbuf  FTP Ϣ
 ֵ  >=0 ɹ
           <0  ʧ
 ע    ""Ҫļбڴʵ
 ********************************************/
int f_conn_server(char *ppat, char *flist, char *zout, char *outbuf)
{
    int    k, b,
           f_err = 0,
           nfile,                           /* ԴļƥĿ */
           ftpfd,                           /* ftp  */
           alive[2] = {0, 0};               /* ״̬ */

    int    hostno = 0;                      /*  */

    char          emsg[EMSG_LEN + 1];       /* ־Ϣ */
    unsigned char ptext[33];                /*  */

    char          szWarnId[9];              /* 澯ID */
    char          szWarnType[9];            /* 澯 */
    int           iWarnLevel = 0;           /* 澯 */

    /*  */
    for( k = 0; k < 2; k++, hostno = ! hostno )
    {
        nfile = 0;
        ftpfd = -1;

        if( u_zcfg.host[hostno][0] == 0 ) continue;

        /* ¼ */
        z_logv(u_logfile, "Connecting %s ...", u_zcfg.host[hostno]);

        memset(ptext, 0, sizeof(ptext));

        if( u_zcfg.encryption == 1 )
            f_pass_decry(u_zcfg.pass[hostno], ptext);
        else
            strcpy((char *)ptext, u_zcfg.pass[hostno]);

        ftpfd = GC_ftp_login(u_zcfg.host[hostno], u_zcfg.ftpport, u_zcfg.user[hostno], (char *)ptext, NULL, outbuf);

        if( ftpfd < 0 )
        {
            z_logv(u_logfile, "Failed");

            if( ftpfd == -3 )
            {
                z_logv(u_logfile, "ڴʧ");
                return(-1);
            }

            continue;
        }

        alive[hostno] = 1;
        z_logv(u_logfile, "done%d", ftpfd);

        /* ƴģʽ */
        if( GC_ftp_transfer_type(ftpfd, 0, outbuf) < 0 )
        {
            f_err = -1;
            strcpy(emsg, "öƴģʽʧ");

            strcpy(szWarnId, "A005");
            strcpy(szWarnType, "APP");
            iWarnLevel = 3;
            break;
        }

        if( flist == NULL ) break;          /* ȡļб */

        /* Զ̹Ŀ¼ */
        if( GC_ftp_cd(ftpfd, u_zcfg.src_path, outbuf) < 0 )
        {
            snprintf(emsg, sizeof(emsg), "Զ·'%s'", u_zcfg.src_path);
            z_logv(u_logfile, emsg);

            /*
             * strcpy(szWarnId, "A006");
             * strcpy(u_pNidWarn->szWarnType, "APP");
             * u_pNidWarn->iWarnLevel = 9;
             */

            close(ftpfd);
            ftpfd = -1;
            continue;
        }

        /* Զļб */
        z_logv(u_logfile, "Listing ...");

        b = GC_ftp_list(ftpfd, ppat, 0, flist, outbuf);
        z_logv(u_logfile, "done");

        if( b == 0 )
            nfile = z_filelines(flist);
        else                                /* ٶƥļ */
        {
            z_rtrim(outbuf);
            z_logv(zout, outbuf);
        }

        if( nfile > 0 )
        {
            u_pruns->leftfiles = nfile;
            break;
        }
        else if( nfile < 0 )
        {
            f_err = -2;
            snprintf(emsg, sizeof(emsg), "ļʧ'%s'", flist);

            strcpy(szWarnId, "O002");
            strcpy(szWarnType, "OS");
            iWarnLevel = 9;
            break;
        }

        close(ftpfd);
        ftpfd = -1;
    }

    if( f_err )
    {
        close(ftpfd);
        f_seterr(emsg, szWarnId, szWarnType, iWarnLevel);

        if( f_err == -1 )
        {
            z_rtrim(outbuf);
            z_logv(zout, outbuf);
        }
        return(-1);
    }

    /* ʧܣִ */
    if( alive[0] == 0 && alive[1] == 0 )
    {
        /*
         * if( f_ping(u_zcfg.host[0]) < 0 )
         *     sprintf(emsg, "ڵ'%s'", u_zcfg.host[0]);
         * else
         *     sprintf(emsg, "ʧ'%s'", u_zcfg.host[0]);
         */

        sprintf(emsg, "¼ʧ'%s'", u_zcfg.host[0]);
        f_seterr(emsg, "N001", "NET", 6);

        return(-1);
    }

    /* ȡļбļĿΪ0֮ǰĴϢ */
    if( flist && nfile == 0 )
    {
        f_set_ok(NULL, NULL, "");
    }

    return(ftpfd);
}

/**************************
 ͨFTP ļ
 **************************/
int f_fsn_rz(char *outbuf)
{
    int  b = 0,
         tmo,
         ftpfd = -1;            /* ftp  */

    unsigned char ptext[33];    /*  */

    if( u_zpara.rz_host[0] == 0 ) return(0);

    memset(ptext, 0, sizeof(ptext));

    if( u_zpara.rz_encryption == 1 )
        f_pass_decry(u_zpara.rz_pass, ptext);
    else
        strcpy((char *)ptext, u_zpara.rz_pass);

    /* FTP ʱʱ */
    tmo = GC_ftp_timeout(u_zpara.rz_timeout);

    ftpfd = GC_ftp_login(u_zpara.rz_host, u_zpara.ftpport, u_zpara.rz_user, (char *)ptext, NULL, outbuf);

    if( ftpfd < 0 || GC_ftp_put(ftpfd, u_fsnfile, u_fsnfile, outbuf) < 0 )
        b = -1;

    if( ftpfd >= 0 ) close(ftpfd);
    GC_ftp_timeout(tmo);

    return(b);
}

/******************************************
 Ź쵱ǰļģʽ
 ڲchar *seq   (NULLʾʹ)
           char *name  Ŀļģʽ
 ******************************************/
void f_seq2name(char *seq, char *name)
{
    char *p = u_zcfg.src_fn_pattern;

    for( ; *p; p++, name++)
    {
        if( *p == SM_SEQHOLDER )
        {
            if( seq )
            {
                if( *seq == 0 ) break;
                *name = *(seq++);
            }
            else *name = SM_HOLDER;
        }
        else
        {
            *name = *p;
        }
    }
    *name = 0;

    return;
}

/************************
 ӵǰļȡ
 ************************/
void f_name2seq(char *name, char *seq)
{
    char *p = u_zcfg.src_fn_pattern;

    for( ; *p && *name; p++, name++)
    {
        if( *p == SM_SEQHOLDER )
        {
            *(seq++) = *name;
        }
    }
    *seq = 0;

    return;
}

/************************************
 ڸʽ·Ĵ
 ڲchar *fpath   ·ʽ
           char *dpath   Ŀ·
 ֵ  0   ɹ
           -1  ʧ
 ************************************/
int f_dtpath_local(char *fpath, char *dpath)
{
    char dtpath[CL];

    struct stat statbuf;

    if( strchr(fpath, SM_PATH_DATE) == NULL )   /* ڸʽ */
    {
        strcpy(dpath, fpath);
        return(0);
    }

    z_get_dt(dtpath, sizeof(dtpath) - 1, fpath, 0);

    /* Ŀ¼ڣ㼶Ŀ¼ */
    if( stat(dtpath, &statbuf) < 0 )
    {
        z_logv(u_logfile, "Making dir ...");
        if( f_mkdirp(dtpath, NEWDIRMODE, NULL) < 0 ) return(-1);
    }
    else if( ! S_ISDIR(statbuf.st_mode) )       /* Ŀ¼ */
    {
        return(-1);
    }
    strcpy(dpath, dtpath);

    return(0);
}

/************************************
 Զ̶ڸʽ·Ĵ
 ڲint   fd      
           char *oldpath ԭ·
           char *fpath   ·ʽ
           char *dpath   Ŀ·
           char *outbuf  FTP Ϣ
 ֵ  0   ڸʽ
           1   Ŀ¼ڣɹ
           2   Ŀ¼Ѵ
           <0  ʧ
 ************************************/
int f_dtpath_remote(int fd, char *oldpath, char *fpath, char *dpath, char *outbuf)
{
    int  b = 0;
    char dtpath[CL];

    if( strchr(fpath, SM_PATH_DATE) == NULL )   /* ڸʽ */
    {
        strcpy(dpath, fpath);
        return(0);
    }

    z_get_dt(dtpath, sizeof(dtpath) - 1, fpath, 0);

    /* Ŀ¼ڣĿ¼ */
    if( GC_ftp_cd(fd, dtpath, outbuf) < 0 )
    {
        b = 1;
        z_logv(u_logfile, "Making remote dir ...");
        if( GC_ftp_mkdir(fd, dtpath, outbuf) < 0 ) return(-1);
    }
    else
    {
        b = 2;
        /* лԭ· */
        if( oldpath && GC_ftp_cd(fd, oldpath, outbuf) < 0 ) return(-2);
    }
    strcpy(dpath, dtpath);

    return(b);
}

/**************************************
 ⵽ָڵͨ
 ڲchar *ip    ڵ
 ֵ  0           
           -1          
 **************************************/
int f_ping(char *ip)
{
    char cmd[CL];

    snprintf(cmd, sizeof(cmd), "ping -c 10 -l 9 %s 1>&- 2>&-", ip);

    if( z_valid_ip(ip) != 4 ) return(0);
    if( system(cmd) ) return(-1);
    return(0);
}

/************************
 ɹ󣬼״̬
 ************************/
int f_set_ok(char *fstr, char *hdftime, char *emsg)
{
    int    i;
    time_t tv;

    /* 澯 */
    for( i = 0; i < sizeof(u_lightwarn[u_careno]) / sizeof(LIGHTWARN); i++ )
    {
        if( u_lightwarn[u_careno][i].szWarnId[0] == 0 ) break;
        u_lightwarn[u_careno][i].iWarnTimes = 0;
    }

    tv = time((time_t *) 0);

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, -1, 0) < 0 ) return(-1);

    for( i = 0; i < u_carecount; i++ )
    {
        if( u_bBreakOnOK == 0 && i != u_careno ) continue;

        if( i >= u_careno )
        {
            u_runs[ u_careslot[i] ].e_report1 = 0;      /* 澯 */
            u_runs[ u_careslot[i] ].e_report2 = 0;
            u_runs[ u_careslot[i] ].e_report3 = 0;

            /* ʱ */
            if( i == u_careno )
            {
                if( emsg[0] == 0 ) u_runs[ u_careslot[i] ].errtime = 0;
                else u_runs[ u_careslot[i] ].errtime = tv;
                strcpy(u_runs[ u_careslot[i] ].errmsg, emsg);
            }
            else
            {
                u_runs[ u_careslot[i] ].errtime = 0;
                u_runs[ u_careslot[i] ].errmsg[0] = 0;
            }
        }

        if( fstr )
        {
            u_runs[ u_careslot[i] ].endtime = tv;       /* ϴβɼʱ */
            u_runs[ u_careslot[i] ].noftime = 0;
            u_runs[ u_careslot[i] ].e_nofrep1 = 0;
            u_runs[ u_careslot[i] ].e_nofrep2 = 0;

            if( i == u_careno )
            {
                strncpy(u_runs[ u_careslot[i] ].currfile, fstr, sizeof(u_runs[ u_careslot[i] ].currfile) - 1);
                u_runs[ u_careslot[i] ].currfile[ sizeof(u_runs[ u_careslot[i] ].currfile) - 1 ] = 0;
            }
        }

        if( hdftime && *hdftime && i == u_careno )
            strcpy(u_runs[ u_careslot[i] ].hdftime, hdftime);
    }

    /*  */
    if( GC_semop(u_semid, SN_LOCATION, 1, 0) < 0 ) return(-1);

    return(0);
}

/******************
 Իӳٵĸ澯
 ******************/
int f_delay_warn(char *ftime, char *pOut)
{
    time_t tNow,                    /* ǰʱ */
           tNoLimit,                /* ļ澯 */
           tCall;                   /* ʱ */

    char   hdtime[16],              /* ʱ */
           emsg[EMSG_LEN + 1];

    if( ftime == NULL || *ftime == 0 ) return(0);

    /* ȷ"ļ"澯 */
    if( u_zcfg.nofile_limit > 0 )
    {
        /* ݸ澯ʱ޸澯 */
        tNoLimit = u_zcfg.nofile_limit;
    }
    else
    {
        /* æʱͳһ澯 */
        if( f_isbusy(u_zcfg.busytime) == 1 )
            tNoLimit = u_zpara.busynofilet;
        else
            tNoLimit = u_zpara.freenofilet;
    }

    /* תʱ䣬ʾ */
    sprintf(hdtime, "%8.8s%2.2s%2.2s%2.2s",
        ftime, ftime + 9, ftime + 12, ftime + 15);

    tCall = z_secs_dt(hdtime, NULL);

    /* ȡϵͳǰʱ */
    tNow = time( (time_t *) 0 );

    if( tCall > 0 && tNow - tCall > tNoLimit )
    {
        sprintf(emsg, "ʱ%s, ӳٳ%ld", ftime, (long)tNoLimit);
        f_seterr(emsg, W_ID_DELAY, "APP", 9);
        if( pOut ) strcpy(pOut, emsg);
    }

    return(0);
}

/************************
 ǷΪĿ¼
 ֵ  0   ɹ
           -1  ʧ
 ************************/
int f_isdir(char *pDir)
{
    struct stat st;

    if( stat(pDir, &st) == 0 && S_ISDIR(st.st_mode) ) return(0);
    return(-1);
}

/************************************
 ༶Ŀ¼ṹ
 ڲchar *    Ŀ¼
           mode_t    Ŀ¼Ȩ
           char *    ʧʱĲ㼶
 ֵ  0   ɹ
           -1  ʧ
 ************************************/
int f_mkdirp(char *pDir, mode_t iMode, char *pFailDir)
{
    int   n, b;
    char *p, szPart[8];

    static char szDirSave[1024];

    if( pDir == NULL || *pDir == 0 ) return(0);
    if( strlen(pDir) >= sizeof(szDirSave) ) return(-1);

    /* Ŀ¼ */
    strcpy(szDirSave, pDir);

    /* 𼶴Ŀ¼ */
    p = szDirSave;

    do
    {
        b = z_get_fieldv(&p, szPart, &n, sizeof(szPart) - 1, "/");

        /* ضĿ¼ƣõǰ㼶 */
        if( b ) *(p - 1) = 0;

        /* ǰ㼶Ŀ¼ */
        if( szDirSave[0] && f_isdir(szDirSave) < 0 )
        {
            /* ʧܣҲΪĿ¼Ѵڣʧ */
            if( mkdir(szDirSave, iMode) < 0 && f_isdir(szDirSave) < 0 )
            {
                if( pFailDir ) strcpy(pFailDir, szDirSave);
                return(-1);
            }
        }

        /* ָĿ¼ */
        if( b ) *(p - 1) = '/';
    }
    while( b );

    return(0);
}

/**************************
 ļɼɹýű
 **************************/
int f_okshell(FILINFO *fi)
{
    char   szStartDate[16], szEndDate[16];
    static char szCmd[1024];

    if( u_zcfg.okshell[0] )
    {
        z_get_dt(szStartDate, 14, "f", fi->tStartTv.tv_sec);
        z_get_dt(szEndDate, 14, "f", fi->tEndTv.tv_sec);

        snprintf(szCmd, sizeof(szCmd), "%s/%s '%s+%s+%s+%ld+%s+%d+%s+%d+%s+%s'",
            u_plugdir, u_zcfg.okshell, u_zcfg.no, fi->fstr, fi->dstfile, fi->fsize,
            szStartDate, (int)(fi->tStartTv.tv_usec), szEndDate,
            (int)(fi->tEndTv.tv_usec), fi->szCrtTime, u_zcfg.desc);

        system(szCmd);
    }

    return(0);
}

/******************
 ɼʧܺýű
 ******************/
int f_failshell(int r, FILINFO *fi)
{
    static char szCmd[1024];

    if( u_zcfg.failshell[0] )
    {
        snprintf(szCmd, sizeof(szCmd), "%s/%s '%s+%s+%s+%d+%s'",
            u_plugdir, u_zcfg.failshell, u_zcfg.no, fi->localpath, u_zcfg.desc, r, t_ftpbuf1);

        system(szCmd);
    }

    return(0);
}

