// MsgTran_impl.cpp: implementation of the MsgTran_impl class.

#include "FoundationLib.h"
#include "MsgTran_impl.h"

using namespace InforGuard;

MsgTran_impl::MsgTran_impl()
{

}

MsgTran_impl::~MsgTran_impl()
{

}

//ӷϢ
CORBA::Long MsgTran_impl::GetMessage(const InforGuard::HostChain& seqIpPort,
									 InforGuard::MsgBlock_out mb)
									 throw(InforGuard::ExceptionError,CORBA::SystemException)
{
	return 0;
}

//Ϣ
CORBA::Long MsgTran_impl::PutMessage(const InforGuard::HostChain& seqIpPort,
									 const InforGuard::MsgBlock& mb)
									 throw(InforGuard::ExceptionError,CORBA::SystemException)
{
	string sParam;
	sParam = sParam
		+ "mb[" + MB2String( mb )
		+ "]seqIpPort[" + HostChainToString(seqIpPort)
		+ "]";

	cout << sParam << endl; 

	return 0;
}


string MsgTran_impl::MB2String( const InforGuard::MsgBlock& mb )
{
	char sTmp[16] = {0};
	string sParam;
	sParam = "mid[" + MsgIdToString( (enumMsgID)mb.mid )
		+ "]lvl[" + NumberFormatter::format(mb.level)
		+ "]sil[" + NumberFormatter::format(mb.serial)
		+ "]";
	int nCount = mb.pl.length();
	for (int i=0; i<nCount; i++)
	{
		sParam = sParam + "pl(" + NumberFormatter::format(i) + ")[" + mb.pl[i] + "]";
	}
	return sParam;
}


string MsgTran_impl::HostChainToString(const InforGuard::HostChain& hostchain)
{
	long nCount = hostchain.length();
	string sChain;

	for (long i = 0; i < nCount; i++)
	{
		sChain += "IP[";
		sChain += hostchain[i].sIp;
		sChain += "]PORT[";
		sChain += hostchain[i].sPort;
		sChain += "]";
	}

	return sChain;
}


string MsgTran_impl::MsgIdToString( enumMsgID id )
{
	switch( id )
	{
	case MID_UI_MC_ADD_HOSTGROUP:			return "";
	case MID_UI_MC_GET_HOSTGROUP:			return "ȡ";
	case MID_UI_MC_DELETE_HOSTGROUP:					return "ɾ";
	case MID_UI_MC_RENAME_HOSTGROUP:				return "";
	case MID_UI_MC_ADD_HOST:				return "";
	case MID_UI_MC_DELETE_HOST:			return "ɾ";

	case MID_UI_MC_ADD_WEBSITEGROUP:				return "վ";
	case MID_UI_MC_GET_WEBSITEGROUP:			return "ȡվ";
	case MID_UI_MC_DELETE_WEBSITEGROUP:					return "ɾվ";
	case MID_UI_MC_RENAME_WEBSITEGROUP:				return "վ";

	case MID_UI_MC_ADD_WEBSITE:			return "վ";
	case MID_UI_MC_GET_WEBSITE:			return "ȡվ";
	case MID_UI_MC_DELETE_WEBSITE:		return "ɾվ";
	case MID_UI_MC_EDIT_WEBSITE:	return "޸վ(\\ýվ\\޸վ)";
	case MID_UI_MC_GET_POLICY:				return "ȡվ";
	case MID_UI_MC_SET_POLICY:			return "վ";

	case MID_UI_MC_ADD_WEBSITEDIR:			return "վĿ¼";
	case MID_UI_MC_GET_WEBSITEDIR:		return "ȡվĿ¼";
	case MID_UI_MC_EDIT_WEBSITEDIR:			return "޸վĿ¼";
	case MID_UI_MC_DELETE_WEBSITEDIR:		return "ɾվĿ¼";
	case MIC_MC_REMOVE_DIR_MARK:            return "ɾĿ¼ˮӡ";
	case MIC_MC_REMOVE_WEBSITE_MARK:        return "ɾվˮӡ";  
	case MIC_MC_ADD_MARK:                   return "ˮӡ";

	case MID_UI_MC_GET_MONITOR_STATE:			return "ȡ״̬";
	case MID_UI_MC_GET_AUTO_UPDATE_STATE:			return "ȡԶͬ״̬";
	case MID_UI_MC_SET_MONITOR_STATE:					return "\\ͣ";
	case MID_UI_MC_SET_AUTO_UPDATE_STATE:				return "\\ͣԶͬ";

	case MID_UI_MC_GET_ALARMSET:				return "ȡ";
	case MID_UI_MC_SET_ALARMSET:			return "д";

	case MID_UI_MC_GET_FOLDERLIST:				return "ȡĿ¼Ŀ¼";
	case MID_UI_MC_GET_FILELIST:				return "ȡĿ¼ļ";
	case MID_UI_MC_BACKUP:			return "ȫ\\";
	case MID_UI_MC_RESTORE:			return "ȫ\\ͬ";
	case MID_UI_MC_GET_RUN_INFOR:			return "ȡ̨Ϣ";
	case MID_UI_MC_GET_PLAN:			return "ȡ";

	case MID_MC_UI_TRACE:					return " Ϣ";
	//case MID_TOTAL_SIZE:					return "";
	//case MID_MA_UI_TOTAL_SIZE:			return "";
	case MID_SA_UI_TOTAL_SIZE:				return "";
	//case MID_FINISH_SIZE:					return " ɴ";
	//case MID_FINISHED:						return "ɴ";
	case MID_MA_UI_FINISH_SIZE:				return "ɴ";
	//case MID_SA_UI_FINISH_SIZE:				return "ɴ";
	
	default:								return "δ֪";
	}
}


