//---------------------------------------------------------------------------

#ifndef BatchUpdateH
#define BatchUpdateH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "gcps.h"

//---------------------------------------------------------------------------
class TFrmBatchUpdate : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TButton *BtnFilterCond;
        TButton *BtnUpdate;
        TButton *BtnCheck;
        TButton *BtnFilter;
        TButton *BtnUpdateExpr;
        TButton *BtnClear;
        TButton *Button1;
        TLabel *Label1;
        TEdit *EditTotal;
        TPanel *Panel2;
        TMemo *MemoReport;
        TStatusBar *StatusBar1;
        TPanel *Panel3;
        TListView *ListView1;
        TPanel *Panel4;
        TCheckBox *ChkBoxAll;
        TCheckBox *ChkBoxAllNot;
        TButton *BtnBatStart;
        TButton *BtnBatStop;
        TButton *BtnStatRef;

        void __fastcall BtnFilterCondClick(TObject *Sender);
        void __fastcall BtnUpdateClick(TObject *Sender);
        void __fastcall BtnCheckClick(TObject *Sender);
        void __fastcall BtnFilterClick(TObject *Sender);
        void __fastcall BtnUpdateExprClick(TObject *Sender);
        void __fastcall BtnClearClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ChkBoxAllClick(TObject *Sender);
        void __fastcall ChkBoxAllNotClick(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ListView1SelectItem(TObject *Sender,
          TListItem *Item, bool Selected);
        void __fastcall BtnBatStopClick(TObject *Sender);
        void __fastcall BtnStatRefClick(TObject *Sender);

private:	// User declarations
public:		// User declarations
        __fastcall TFrmBatchUpdate(TComponent* Owner);

        TSocket m_skt;

                                                // 
        char    m_szDesc[65];                   // 
        char    m_szHost[17];                   // 
        char    m_szDstPath[129];               // Ŀ·
        char    m_szFileAnalyzer[65];           // 
        int     m_iOperType;                    // 
        int     m_iSeqCtrl;                     // Ƿϸſ
        int     m_iCheck[32];                   // Ƿʹ

                                                // ޸ĸֵ
        char    u_szHostPair[34];               // IP
        char    u_szPassPair[66];               // 
        char    u_szFileAnalyzer[65];           // 
        char    u_szSrcPattern[65];             // Դƥģʽ
        char    u_szDstPath[129];               // Ŀ·
        char    u_szDstNameFormat[65];          // Ŀתʽ
        int     u_iBusyItv;                     // æʱɼ
        int     u_iFreeItv;                     // ʱɼ
        int     u_iNoLimit;                     // ļ澯ʱ
        int     u_iExtraCopy;                   // ⿽
        int     u_iCheck[32];                   // Ƿʹ
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmBatchUpdate *FrmBatchUpdate;
//---------------------------------------------------------------------------
#endif
