//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "Config.h"
#include "Fpub.h"
#include "RegTest.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmConfig *FrmConfig;

//---------------------------------------------------------------------------
__fastcall TFrmConfig::TFrmConfig(TComponent* Owner) : TForm(Owner)
{
        m_serv_no = 0;                  // ɼ
        m_bChecked = 0;                 // δ

        m_nColSize = 0;                 // ļС
        m_nExtraCopy = 0;               // Ᵽ漸
        m_nRecordSize = 0;              // С
        m_nSeqLength = 0;               // ų
        m_nNoFileLimit = 0;             // ޻澯ʱ
        m_nOperTimeout = 0;             // ʱʱ

        m_nBusyItv = m_nFreeItv = -1;   // æвɼ
        m_nSeqMin = m_nSeqMax = 0;      // ֹ
        m_nSeqCurr = 0;                 // ǰ

        // æʱʱ
        memset(m_szBusyBeg, 0, sizeof(m_szBusyBeg));
        memset(m_szBusyEnd, 0, sizeof(m_szBusyEnd));

        EditDstNameFormat->Hint = Label13->Hint;
}

//---------------------------------------------------------------------------
// ԶȡɼϢ
void __fastcall TFrmConfig::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        char *pStat;

        if( Tag == 0 )                  // ͨ˵
        {
                EditNo->Enabled = true;
                EditNo->Color = clWindow;

                // rootû༭ɼĹֹ˾
                if( atoi(g_userid) == 0 )
                {
                        EditBelong->Enabled = true;
                        EditBelong->Color = clWindow;
                }
                else
                {
                        EditBelong->Text = g_username;
                        m_serv_no = g_hostseq;
                }
        }
        else
        {
                m_serv_no = Tag - 1;
        }

        if( EditBelong->Text.Trim().Length() == 0 || EditNo->Text.Trim().Length() == 0 ) return;

        BtnDownLoadClick(Sender);
}

//---------------------------------------------------------------------------
// ʱ༭Դ·
void __fastcall TFrmConfig::RadioGrpDelBakClick(TObject *Sender)
{
        if( RadioGrpDelBak->ItemIndex == 1 )
        {
                EditSrcBakPath->Enabled = true;
                EditSrcBakPath->Color = clWindow;
        }
        else
        {
                EditSrcBakPath->Enabled = false;
                EditSrcBakPath->Color = clGrayText;
        }
}

//---------------------------------------------------------------------------
// ϸſƻŸ澯ʱ༭ֹ
void __fastcall TFrmConfig::ChkBoxSeqCtrlClick(TObject *Sender)
{
        EditSeqMin->Enabled = false;
        EditSeqMax->Enabled = false;
        EditSeqCurr->Enabled = false;
        EditSeqMin->Color = clGrayText;
        EditSeqMax->Color = clGrayText;
        EditSeqCurr->Color = clGrayText;

        if( ChkBoxSeqCtrl->Checked == true )
        {
                EditSeqMin->Enabled = true;
                EditSeqMax->Enabled = true;
                EditSeqMin->Color = clWindow;
                EditSeqMax->Color = clWindow;

                if( Tag == 0 )
                {
                        EditSeqCurr->Enabled = true;
                        EditSeqCurr->Color = clWindow;
                }
        }
        else if( ChkBoxSeqBreakWarn->Checked == true )
        {
                EditSeqMin->Enabled = true;
                EditSeqMax->Enabled = true;
                EditSeqMin->Color = clWindow;
                EditSeqMax->Color = clWindow;
        }
}

//---------------------------------------------------------------------------
// רæʱʱζ
void __fastcall TFrmConfig::ChkBoxBusyTimeClick(TObject *Sender)
{
        if( ChkBoxBusyTime->Checked == true )
        {
                DTimeBegin->Enabled = true;
                DTimeEnd->Enabled = true;
                DTimeBegin->Color = clWindow;
                DTimeEnd->Color = clWindow;
        }
        else
        {
                DTimeBegin->Enabled = false;
                DTimeEnd->Enabled = false;
                DTimeBegin->Color = clGrayText;
                DTimeEnd->Color = clGrayText;
        }
}

//---------------------------------------------------------------------------
// ֤Ϣ
int __fastcall TFrmConfig::VerifyText(void)
{
        int   nRead;
        char *p, szBuf[256];

        // ֤ɼ
        if( EditNo->Text.Trim().Length() == 0 )
        {
                ErrDlg("ɼΪ");
                return 1;
        }

        // ֹ֤˾
        if( EditBelong->Text.Trim().Length() == 0 )
        {
                ErrDlg("ֹ˾Ϊ");
                return 1;
        }

        // ֤IPַ
        if( EditIP1->Text.Trim().Length() == 0 )
        {
                ErrDlg("IP");
                return 2;
        }

        // ֤IPַ
        if( EditIP2->Text.Trim().Length() > 0 && z_valid_ip(EditIP2->Text.Trim().c_str()) != 4 )
        {
                ErrDlg("IPǷ");
                return 4;
        }

        // ֤û
        if( EditUser1->Text.Trim().Length() == 0 )
        {
                ErrDlg("û1Ϊ");
                return 5;
        }

        // ֤
        if( EditPass1->Text.Trim().Length() == 0 )
        {
                ErrDlg("1Ϊ");
                return 6;
        }

        // ָIPʱ֤û22
        if( EditIP2->Text.Trim().Length() > 0 )
        {
                // ֤û
                if( EditUser2->Text.Trim().Length() == 0 )
                {
                        ErrDlg("û2Ϊ");
                        return 7;
                }

                // ֤
                if( EditPass2->Text.Trim().Length() == 0 )
                {
                        ErrDlg("2Ϊ");
                        return 8;
                }
        }

        // ֤Դ·
        if( EditSrcPath->Text.Trim().Length() == 0 )
        {
                ErrDlg("Դ·Ϊ");
                return 9;
        }

        // ֤Դ·
        if( RadioGrpDelBak->ItemIndex == 1 )
        {
                if( EditSrcBakPath->Text.Trim().Length() == 0 )
                {
                        ErrDlg("Դ·Ϊ");
                        return 10;
                }
        }

        // ֤Ŀ·
        if( EditDstPath->Text.Trim().Length() == 0 )
        {
                ErrDlg("Ŀ·Ϊ");
                return 11;
        }

        // ֤ɼ
        if( EditBusyItv->Text.Trim().Length() == 0 )
        {
                ErrDlg("æʱɼڿ");
                return 12;
        }
        try
        {
                m_nBusyItv = EditBusyItv->Text.ToInt();
        }
        catch (...)
        {
                ErrDlg("æʱɼڷǷ");
                return 13;
        }
        if( m_nBusyItv <= 0 )
        {
                ErrDlg("æʱɼڷǷ");
                return 14;
        }

        // ʱɼ
        if( EditFreeItv->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nFreeItv = EditFreeItv->Text.Trim().ToInt();
                }
                catch (...)
                {
                }
        }

        if( m_nFreeItv <= 0 )
        {
                m_nFreeItv = m_nBusyItv;
                EditFreeItv->Text = m_nFreeItv;
        }

        // ֤ļС
        if( EditColSize->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nColSize = EditColSize->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("[С]ŷǷ");
                        return 15;
                }
                if( m_nColSize < 0 )
                {
                        ErrDlg("[С]ŷǷ");
                        return 16;
                }
        }

        // ֤Ᵽ漸
        if( EditExtraCopy->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nExtraCopy = EditExtraCopy->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("ⱣǷ");
                        return 15;
                }
                if( m_nExtraCopy < 0 )
                {
                        ErrDlg("ⱣǷ");
                        return 16;
                }
        }

        // ֤С
        if( EditRecordSize->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nRecordSize = EditRecordSize->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("СǷ");
                        return 17;
                }
                if( m_nRecordSize < 0 )
                {
                        ErrDlg("СǷ");
                        return 18;
                }
        }

        // ֤ʱʱ
        if( EditOperTimeout->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nOperTimeout = EditOperTimeout->Text.Trim().ToInt();
                }
                catch (...)
                {
                }
                if( m_nOperTimeout < 0 )
                {
                        ErrDlg("ʱʱ޷Ƿ");
                        return 19;
                }
        }

        // ֤޻澯ʱ
        if( EditNoFileLimit->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_nNoFileLimit = EditNoFileLimit->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("޻澯ʱ޷Ƿ");
                        return 23;
                }
        }

        // ֤æʱʱ
        if( ChkBoxBusyTime->Checked == true )
        {
                strcpy(m_szBusyBeg, DTimeBegin->Time.FormatString("HH:mm").c_str());
                strcpy(m_szBusyEnd, DTimeEnd->Time.FormatString("HH:mm").c_str());

                if( strcmp(m_szBusyBeg, m_szBusyEnd) > 0 )
                {
                        ErrDlg("æʱʱηǷ");
                        return 25;
                }
        }

        // ؼ
        if( ChkBoxSeqBreakWarn->Checked == true || ChkBoxSeqCtrl->Checked == true )
        {
                // ֤Դƥģʽ
                if( EditSrcPattern->Text.Trim().Length() == 0 ||
                    strchr(EditSrcPattern->Text.Trim().c_str(), SM_ASTERISK) )
                {
                        sprintf(szBuf, "ſʱԴģʽвʹ%cֻʹռλ%c%c%c",
                                SM_ASTERISK, SM_HOLDER, SM_SEQHOLDER, SM_SEQHOLDER);
                        ErrDlg(szBuf);
                        return 26;
                }

                // ֤ŷΧ
                if( EditSeqMin->Text.Trim().Length() == 0 || EditSeqMax->Text.Trim().Length() == 0 )
                {
                        ErrDlg("ŷΧǷ");
                        return 27;
                }
                try
                {
                        m_nSeqMin = EditSeqMin->Text.Trim().ToInt();
                        m_nSeqMax = EditSeqMax->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("ŷΧǷ");
                        return 28;
                }

                if( m_nSeqMin < 0 || m_nSeqMax < 0 || m_nSeqMin > m_nSeqMax )
                {
                        ErrDlg("ŷΧǷ");
                        return 29;
                }

                // ų
                m_nSeqLength = EditSeqMax->Text.Trim().Length();

                if( EditSeqMin->Text.Trim().Length() != m_nSeqLength )
                {
                        sprintf(szBuf, "%0*d", m_nSeqLength, m_nSeqMin);
                        EditSeqMin->Text = szBuf;
                }

                // ͳռλĿ
                p = EditSrcPattern->Text.Trim().c_str();
                nRead = 0;

                while( *p )
                {
                    if( *(p++) == SM_SEQHOLDER ) nRead++;
                }

                if( nRead != m_nSeqLength )
                {
                        sprintf(szBuf, "Դģʽռλ%c%cĿųȲһ",
                                SM_SEQHOLDER, SM_SEQHOLDER);
                        ErrDlg(szBuf);
                        return 30;
                }

                // ֤ǰ
                if( Tag == 0 && ChkBoxSeqCtrl->Checked == true )
                {
                        if( EditSeqCurr->Text.Trim().Length() == 0 )
                        {
                                ErrDlg("ǰŷǷ");
                                return 31;
                        }
                        try
                        {
                                m_nSeqCurr = EditSeqCurr->Text.Trim().ToInt();
                        }
                        catch (...)
                        {
                                ErrDlg("ǰŷǷ");
                                return 32;
                        }

                        if( m_nSeqCurr < m_nSeqMin || m_nSeqCurr > m_nSeqMax )
                        {
                                ErrDlg("ǰŷǷ");
                                return 33;
                        }

                        // 㵱ǰų
                        if( EditSeqCurr->Text.Trim().Length() != m_nSeqLength )
                        {
                                sprintf(szBuf, "%0*d", m_nSeqLength, m_nSeqCurr);
                                EditSeqCurr->Text = szBuf;
                        }
                }
        }

        return(0);
}

//---------------------------------------------------------------------------
// ϴϢ
int __fastcall TFrmConfig::SaveConfig(void)
{
        int   b, fTry = 1;
        char *pBody, szVal[64];

        static char szBody[4096];

        // ֤Ϣ
        if( VerifyText() ) return(-1);

        // ɼĲá
        m_skt.SetHeadN((Tag == 0 ? TC_ACFGONE : TC_WCFGONE), 2);

//---------------------------------------------------------------------------
        // ʽTLV
        // Tag(1)Length(4)

        pBody = szBody;

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);

        // ɼ
        f_packTLV(&pBody, EditDesc->Text.Trim().c_str(), TAG_DESCRIPTION);

        // ͡
        sprintf(szVal, "%d", RadioGrpOperType->ItemIndex);
        f_packTLV(&pBody, szVal, TAG_OPERATION_TYPE);

        // ɼģʽǰ2λ
        sprintf(szVal, "%d%d",
                ChkBoxLatest->Checked == true ? 1 : 0,
                ChkBoxNoTmpName->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_GATHER_MODE);

        // IP
        f_packTLV(&pBody, EditIP1->Text.Trim().c_str(), TAG_HOSTIP1);

        // IP
        f_packTLV(&pBody, EditIP2->Text.Trim().c_str(), TAG_HOSTIP2);

        // û
        f_packTLV(&pBody, EditUser1->Text.Trim().c_str(), TAG_USER1);

        // û
        f_packTLV(&pBody, EditUser2->Text.Trim().c_str(), TAG_USER2);

        // 
        f_packTLV(&pBody, EditPass1->Text.Trim().c_str(), TAG_PASSWORD1);

        // 
        f_packTLV(&pBody, EditPass2->Text.Trim().c_str(), TAG_PASSWORD2);

        // Ƿܡ
        sprintf(szVal, "%d", ChkBoxEncry->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_ENCRYPTION);

        // Դƥģʽ
        f_packTLV(&pBody, EditSrcPattern->Text.Trim().c_str(), TAG_SRC_PATTERN);

        // Դʽ
        f_packTLV(&pBody, EditSrcNameFilter->Text.Trim().c_str(), TAG_SRC_NAME_FILTER);

        // Դɾ־
        sprintf(szVal, "%d", RadioGrpDelBak->ItemIndex);
        f_packTLV(&pBody, szVal, TAG_SRC_MOVEDEL);

        // Դ·
        f_packTLV(&pBody, EditSrcPath->Text.Trim().c_str(), TAG_SRC_PATH);

        // Դ·
        f_packTLV(&pBody, EditSrcBakPath->Text.Trim().c_str(), TAG_SRC_BACKUP_PATH);

        // Ŀ·
        f_packTLV(&pBody, EditDstPath->Text.Trim().c_str(), TAG_DEST_PATH);

        // Ŀתʽ
        f_packTLV(&pBody, EditDstNameFormat->Text.Trim().Trim().c_str(), TAG_DEST_NAME_FORMAT);

        // æʱʱΡ
        if( ChkBoxBusyTime->Checked == true )
        {
                sprintf(szVal, "%s%c%s", m_szBusyBeg, SM_SEQHYPHEN, m_szBusyEnd);
                f_packTLV(&pBody, szVal, TAG_BUSY_TIME);
        }

        // æʱɼڡ
        sprintf(szVal, "%d", m_nBusyItv);
        f_packTLV(&pBody, szVal, TAG_BUSY_INTERVAL);

        // ʱɼڡ
        sprintf(szVal, "%d", m_nFreeItv);
        f_packTLV(&pBody, szVal, TAG_FREE_INTERVAL);

        // ļ澯ʱޡ
        sprintf(szVal, "%d", m_nNoFileLimit);
        f_packTLV(&pBody, szVal, TAG_NOFILE_LIMIT);

        // ʱޡ
        sprintf(szVal, "%d", m_nOperTimeout);
        f_packTLV(&pBody, szVal, TAG_FTP_TIMEOUT);

        // 
        f_packTLV(&pBody, EditFileAnalyzer->Text.Trim().c_str(), TAG_FILE_ANALYZER);

        // Ƿſơ
        sprintf(szVal, "%d", ChkBoxSeqCtrl->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_SEQUENCE_CONTROL);

        // ŷΧ
        sprintf(szVal, "%0*d%c%0*d", m_nSeqLength, m_nSeqMin, SM_SEQHYPHEN, m_nSeqLength, m_nSeqMax);
        f_packTLV(&pBody, szVal, TAG_SEQUENCE_SCOPE);

        // ǰš
        sprintf(szVal, "%0*d", m_nSeqLength, m_nSeqCurr);
        f_packTLV(&pBody, szVal, TAG_SEQCURR);

        // 澯ģʽǰ2λ
        sprintf(szVal, "%d%d", ChkBoxZeroWarn->Checked == true ? 1 : 0, ChkBoxSeqBreakWarn->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_WARN_MODE);

        // ¼С
        sprintf(szVal, "%d", m_nRecordSize);
        f_packTLV(&pBody, szVal, TAG_RECORD_SIZE);

        // [С]С
        sprintf(szVal, "%d", m_nColSize);
        f_packTLV(&pBody, szVal, TAG_SIZE_COL);

        // Ᵽ漸ݡ
        sprintf(szVal, "%d", m_nExtraCopy);
        f_packTLV(&pBody, szVal, TAG_EXTRACOPY);

        // FTPϵ־
        sprintf(szVal, "%d", ChkBoxFtpResume->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_FTP_RESUME);

        // FTPģʽ־
        sprintf(szVal, "%d", ChkBoxFtpPassive->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_FTP_PASSIVE);

        // ñ־
        sprintf(szVal, "%d", ChkBoxEnable->Checked == true ? 1 : 0);
        f_packTLV(&pBody, szVal, TAG_STATUS);

        *pBody = 0;
//---------------------------------------------------------------------------

        // ݲɼĹֹ˾ӶӦķ
        if( Tag > 0 ) fTry = 0;
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1, 1, 0, &fTry);

        // ֹ˾һ
        if( Tag == 0 && fTry == 0 )
        {
                m_serv_no = ! m_serv_no;
        }

        char szBuf[8] = {0};

        switch( b )
        {
        case R_OK:
                MessageDlg("ϴɹ", mtInformation, TMsgDlgButtons() << mbOK, 0);
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                m_skt.GetHeadN(szBuf, 3);       // 

                if( szBuf[0] == E_LOGONDENY )
                        ErrDlg("ֹ˾Ч");
                else if( szBuf[0] == E_FILE )
                        ErrDlg("ļʧ");
                else
                        ErrDlg("ʧ");

                break;
        }

        // ɼʱһ̨ͬȨϢ
        if( Tag == 0 )
        {
                m_skt.SetHeadN(TC_AUTHONLY, 2);

//---------------------------------------------------------------------------
                // ʽTLV
                // Tag(1)Length(4)

                pBody = szBody;

                // ֹ˾
                f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

                // ɼš
                f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);
                *pBody = 0;

                if( SktComm(m_skt, (!m_serv_no) + 1, szBody, StatusBar1) != R_OK )
                        ShowStatus("ͬȨϢʧ", StatusBar1);
        }

        return(0);
}

//---------------------------------------------------------------------------
// ϴť
void __fastcall TFrmConfig::BtnUpLoadClick(TObject *Sender)
{
        TModalResult r;

        if( m_bChecked == 0 )
        {
                ErrDlg("ȸ");
                return;
        }
        m_bChecked = 0;

        r = MessageDlg("ȷϢȷ\r\n[ɼ][ֹ˾]\r\nǷ?",
                mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0);

        if( r != mrYes ) return;

        SaveConfig();
}

//---------------------------------------------------------------------------
// ť
void __fastcall TFrmConfig::BtnStartClick(TObject *Sender)
{
        int   b, fTry = 1;
        char *pBody, szBody[64];

        // ֤ɼ
        if( EditNo->Text.Trim().Length() == 0 )
        {
                ErrDlg("ɼΪ");
                return;
        }

        // ֹ֤˾
        if( EditBelong->Text.Trim().Length() == 0 )
        {
                ErrDlg("ֹ˾Ϊ");
                return;
        }

        TModalResult r = MessageDlg("СʾϢȱ档Ƿ?",
                mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0);

        if( r != mrYes ) return;

        // 䱨ͷ
        m_skt.SetHeadN(TC_START, 2);

        pBody = szBody;

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

        *pBody = 0;

        if( Tag > 0 ) fTry = 0;
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1, 1, 0, &fTry);

        // ֹ˾һ
        if( Tag == 0 && fTry == 0 && atoi(g_userid) )
        {
                m_serv_no = ! m_serv_no;
        }

        char szBuf[8] = {0};

        switch( b )
        {
        case R_OK:
                MessageDlg("ɹڼش֤", mtInformation, TMsgDlgButtons() << mbOK, 0);
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                m_skt.GetHeadN(szBuf, 3);       // 

                if( szBuf[0] == E_LOGONDENY )
                        ErrDlg("ֹ˾Ч");
                else if( szBuf[0] == E_FILE )
                        ErrDlg("ļʧ");
                else
                        ErrDlg("ʧ");

                break;
        }
}

//---------------------------------------------------------------------------
// 
int __fastcall SeekComponent(TComponent *Owner, int tag)
{
        int i;

        for( i = 0; i < Owner->ComponentCount; i++ )
        {
                if( Owner->Components[i]->Tag == tag ) return(i);
        }

        return(-1);
}

// Ԥ
int __fastcall FillComponent(TComponent *Owner)
{
        int i, j, k;

        TEdit     *pEdit;
        TMemo     *pMemo;
        TCheckBox *pChkBox;

        for( i = 0; i < MAXN_TAG; i++ )
        {
                if( g_TAGs[i].tag == 0 ) break;

                // λӦ
                if( g_TAGs[i].wintag > 0 && (k = SeekComponent(Owner, g_TAGs[i].wintag)) >= 0 )
                {
                        if( g_TAGs[i].wintag < 1000 )   // TEdit 
                        {
                                pEdit = static_cast<TEdit *>(Owner->Components[k]);
                                if( pEdit ) pEdit->Text = g_TAGs[i].pv;
                                else
                                {
                                        pMemo = static_cast<TMemo *>(Owner->Components[k]);
                                        if( pMemo ) pMemo->Text = g_TAGs[i].pv;
                                }
                        }
                        else                            // TCheckBox 
                        {
                                j = 0;
                                do {
                                        pChkBox = static_cast<TCheckBox *>(Owner->Components[k]);

                                        if( g_TAGs[i].pv[j] == '1' )
                                                pChkBox->Checked = true;
                                        else
                                                pChkBox->Checked = false;

                                        j++;
                                } while( j < g_TAGs[i].vlen && (k = SeekComponent(Owner, g_TAGs[i].wintag + j)) >= 0 );
                        }
                }
        }

        return(0);
}

// װϢ
int __fastcall TFrmConfig::LoadConfig(void)
{
        int   i, k, j,
              tag1, tag2,
              nHour1, nMin1,
              nHour2, nMin2;

        char *p, *pDeli, szDeli[8],
              szBuf[64], szStr1[64], szStr2[64];

        p = m_skt.GetReply() + m_skt.GetHeadLen();

        // һÿTAG
        if( f_unpackTLV(p, m_skt.GetPktLen() - m_skt.GetHeadLen()) < 0 ) return(-1);

        // ŷΧָ
        szDeli[0] = SM_SEQHYPHEN;
        szDeli[1] = 0;

        // ֶΣֵʱTAG
        for( i = 0; i < MAXN_TAG; i++ )
        {
                if( g_TAGs[i].tag == 0 ) break;

                tag1 = tag2 = 0;
                switch( g_TAGs[i].tag )
                {
                case TAG_HOSTIP_PAIR:           // IP

                        tag1 = TAG_HOSTIP1;
                        tag2 = TAG_HOSTIP2;
                        pDeli = SM_HYPHEN;
                        break;

                case TAG_USER_PAIR:             // û

                        tag1 = TAG_USER1;
                        tag2 = TAG_USER2;
                        pDeli = SM_HYPHEN;
                        break;

                case TAG_SEQUENCE_SCOPE:        // ֹ

                        tag1 = TAG_SEQMIN;
                        tag2 = TAG_SEQMAX;
                        pDeli = szDeli;
                        break;
                }

                if( tag1 > 0 && tag2 > 0 )
                {
                        p = g_TAGs[i].pv;
                        GC_get_fieldv(&p, szStr1, NULL, sizeof(szStr1) - 1, pDeli);
                        GC_get_fieldv(&p, szStr2, NULL, sizeof(szStr2) - 1, pDeli);

                        f_setTAG(tag1, szStr1);
                        f_setTAG(tag2, szStr2);
                }
        }

        // Ԥ
        FillComponent(this);

        // 
        for( i = 0; i < MAXN_TAG; i++ )
        {
                if( g_TAGs[i].tag == 0 ) break;

                switch( g_TAGs[i].tag )
                {
                case TAG_OPERATION_TYPE:        // 

                        if( *(g_TAGs[i].pv) == SM_FTPGET ) k = 0;
                        else if( *(g_TAGs[i].pv) == SM_FTPPUT ) k = 1;
                        else if( *(g_TAGs[i].pv) == SM_FTPNOKIA ) k = 2;
                        else if( *(g_TAGs[i].pv) == SM_FTAM ) k = 3;
                        else return(-1);

                        RadioGrpOperType->ItemIndex = k;
                        break;

                case TAG_SRC_MOVEDEL:           // Դɾ־

                        if( *(g_TAGs[i].pv) == '1' ) k = 0;
                        else if( *(g_TAGs[i].pv) == '2' ) k = 1;
                        else if( *(g_TAGs[i].pv) == '0' ) k = 2;
                        else return(-1);

                        RadioGrpDelBak->ItemIndex = k;
                        break;

                case TAG_GATHER_MODE:           // ɼģʽ

                        if( strchr(g_TAGs[i].pv, SM_NOLATEST) )
                                ChkBoxLatest->Checked = false;
                        else
                                ChkBoxLatest->Checked = true;

                        if( strchr(g_TAGs[i].pv, SM_NOTMPNAME) )
                                ChkBoxNoTmpName->Checked = true;
                        else
                                ChkBoxNoTmpName->Checked = false;

                        break;

                case TAG_BUSY_TIME:             // æʱʱ

                        p = g_TAGs[i].pv;

                        if( *p == 0 )
                        {
                                ChkBoxBusyTime->Checked = false;
                                DTimeBegin->Enabled = false;
                                DTimeBegin->Color = clGrayText;
                                DTimeEnd->Enabled = false;
                                DTimeEnd->Color = clGrayText;

                                break;
                        }

                        ChkBoxBusyTime->Checked = true;
                        DTimeBegin->Enabled = true;
                        DTimeBegin->Color = clWindow;
                        DTimeEnd->Enabled = true;
                        DTimeEnd->Color = clWindow;

                        GC_get_fieldv(&p, szStr1, NULL, sizeof(szStr1) - 1, szDeli);
                        GC_get_fieldv(&p, szStr2, NULL, sizeof(szStr2) - 1, szDeli);

                        // ʼСʱ
                        p = szStr1;
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nHour1 = atoi(szBuf);
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nMin1 = atoi(szBuf);

                        // ֹСʱ
                        p = szStr2;
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nHour2 = atoi(szBuf);
                        GC_get_fieldv(&p, szBuf, NULL, 2, ":");
                        nMin2 = atoi(szBuf);

                        try
                        {
                                DTimeBegin->Time = TDateTime(nHour1, nMin1, 0, 0);
                                DTimeEnd->Time = TDateTime(nHour2, nMin2, 0, 0);
                        }
                        catch(...)
                        {
                        }

                        break;
                }
        }

        return(0);
}

//---------------------------------------------------------------------------
// Ϣť
void __fastcall TFrmConfig::BtnDownLoadClick(TObject *Sender)
{
        int   b, len, fTry = 1;
        char *pBody, szBody[128];

        // ֤ɼ
        if( EditNo->Text.Trim().Length() == 0 )
        {
                ErrDlg("ɼΪ");
                return;
        }

        // ֹ֤˾
        if( EditBelong->Text.Trim().Length() == 0 )
        {
                ErrDlg("ֹ˾Ϊ");
                return;
        }

        // 
        m_skt.SetHeadN(TC_RCFGONE, 2);

        pBody = szBody;

        // ֹ˾
        f_packTLV(&pBody, EditBelong->Text.Trim().c_str(), TAG_BELONG);

        // ɼš
        f_packTLV(&pBody, EditNo->Text.Trim().c_str(), TAG_NO);
        *pBody = 0;

        int   iHLen = m_skt.GetHeadLen();
        char *pInfo = m_skt.GetReply();

        *pInfo = 0;
        *(pInfo + iHLen) = 0;

        // ݲɼĹֹ˾ӶӦķ
        if( Tag > 0 ) fTry = 0;
        b = SktComm(m_skt, m_serv_no + 1, szBody, StatusBar1, 1, 0, &fTry);

        // ֹ˾һ
        if( Tag == 0 && fTry == 0 && atoi(g_userid) )
        {
                m_serv_no = ! m_serv_no;
        }

        char szBuf[8] = {0};

        switch( b )
        {
        case R_OK:
                // MessageDlg("سɹ", mtInformation, TMsgDlgButtons() << mbOK, 0);
                break;

        case R_COMMFAIL:
                ErrDlg("ͨʧ");
                break;

        case R_DENY:
                m_skt.GetHeadN(szBuf, 3);       // 

                if( szBuf[0] == E_LOGONDENY )
                        ErrDlg("ֹ˾Ч");
                else if( szBuf[0] == E_FILE )
                        ErrDlg("ļ");
                else
                        ErrDlg("ʧ");

                break;
        }

        if( b == R_OK ) LoadConfig();
}

//---------------------------------------------------------------------------
// ʽƥ
void __fastcall TFrmConfig::BtnTestRegexClick(TObject *Sender)
{
        FrmRegTest = new TFrmRegTest(this);
        FrmRegTest->Font = g_Font;

        FrmRegTest->EditPublic->Text = EditSrcNameFilter->Text;
        FrmRegTest->Tag = 1;
        FrmRegTest->ShowModal();

        delete FrmRegTest;
        FrmRegTest = NULL;
}

//---------------------------------------------------------------------------
// Ŀתʽ
void __fastcall TFrmConfig::BtnTestDstNameFormatClick(TObject *Sender)
{
        FrmRegTest = new TFrmRegTest(this);
        FrmRegTest->Font = g_Font;

        FrmRegTest->EditPublic->Text = EditDstNameFormat->Text;
        FrmRegTest->Caption = "Ŀת";
        FrmRegTest->LblPublic->Caption = "Ŀתʽ";

        FrmRegTest->LblDstName->Visible = true;
        FrmRegTest->EditDstName->Visible = true;

        FrmRegTest->Tag = 2;
        FrmRegTest->ShowModal();

        delete FrmRegTest;
        FrmRegTest = NULL;
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmConfig::BtnCheckClick(TObject *Sender)
{
        m_bChecked = 1;
}
//---------------------------------------------------------------------------

