//---------------------------------------------------------------------------
#include <vcl.h>
#include <IniFiles.hpp>
#include <mmsystem.h>
#pragma hdrstop

#include "Main.h"
#include "Face.h"
#include "Fpub.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmFace *FrmFace;

//---------------------------------------------------------------------------
__fastcall TFrmFace::TFrmFace(TComponent* Owner) : TForm(Owner)
{
        Edit1->Text = g_WarnFile;
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmFace::BtnSetFontClick(TObject *Sender)
{
        FrmMain->FontDialog1->Tag = 0;
        FrmMain->FontDialog1->Font = g_Font;

        if( FrmMain->FontDialog1->Execute() )
        {
                FrmMain->FontDialog1->Tag = 1;
                g_Font = FrmMain->FontDialog1->Font;
                ShowStatus("", StatusBar1, 0);
        }
        else
                ShowStatus("ȡ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// ɫ
void __fastcall TFrmFace::BtnSetColorClick(TObject *Sender)
{
        FrmMain->ColorDialog1->Tag = 0;
        FrmMain->ColorDialog1->Color = g_Color;

        if( FrmMain->ColorDialog1->Execute() )
        {
                FrmMain->ColorDialog1->Tag = 1;
                g_Color = FrmMain->ColorDialog1->Color;
                ShowStatus("ɫ", StatusBar1, 0);
        }
        else
                ShowStatus("ȡɫ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// 屣浽ļ
void __fastcall TFrmFace::BtnSaveFontClick(TObject *Sender)
{
        if( FrmMain->FontDialog1->Tag == 0 ) return;

        TIniFile *ini;

        ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );
        ini->WriteString("FONT", "NAME", g_Font->Name);
        ini->WriteInteger("FONT", "SIZE", g_Font->Size);
        ini->WriteInteger("FONT", "COLOR", g_Font->Color);

        delete ini;
        ShowStatus("屣浽ļ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// ɫ浽ļ
void __fastcall TFrmFace::BtnSaveColorClick(TObject *Sender)
{
        if( FrmMain->ColorDialog1->Tag == 0 ) return;

        TIniFile *ini;

        ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );
        ini->WriteString("COLOR", "VALUE", g_Color);

        delete ini;
        ShowStatus("ɫ浽ļ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// 澯ļ
void __fastcall TFrmFace::BtnSetSoundClick(TObject *Sender)
{
        OpenDialog1->Title = "澯ļ";
        OpenDialog1->Tag = 0;
        OpenDialog1->FileName = g_WarnFile;

        if( OpenDialog1->Execute() )
        {
                OpenDialog1->Tag = 1;
                Edit1->Text = OpenDialog1->FileName;
                g_WarnFile = Edit1->Text;
                ShowStatus("澯ļ", StatusBar1, 0);
        }
        else
                ShowStatus("ȡ澯ļ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// 澯ļ仯
void __fastcall TFrmFace::Edit1Change(TObject *Sender)
{
        OpenDialog1->Tag = 1;
        g_WarnFile = Edit1->Text;
}

//---------------------------------------------------------------------------
// 澯ļ浽ļ
void __fastcall TFrmFace::BtnSaveSoundClick(TObject *Sender)
{
        if( OpenDialog1->Tag == 0 ) return;

        TIniFile *ini;

        ini = new TIniFile( ChangeFileExt(Application->ExeName, ".INI") );
        ini->WriteString("WARN", "FILE", g_WarnFile);

        delete ini;
        ShowStatus("澯ļ浽ļ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// 澯
void __fastcall TFrmFace::BtnPlaySoundClick(TObject *Sender)
{
        PlaySound(g_WarnFile.c_str(), NULL, SND_ASYNC | SND_FILENAME);
}

//---------------------------------------------------------------------------
// ȱʡ
void __fastcall TFrmFace::BtnDefaultFontClick(TObject *Sender)
{
        g_Font->Name = DEF_FONT_NAME;
        g_Font->Size = DEF_FONT_SIZE;
        g_Font->Color = TColor( DEF_FONT_COLOR );

        FrmMain->FontDialog1->Tag = 1;
        ShowStatus("ָΪȱʡֵ", StatusBar1, 0);
}

//---------------------------------------------------------------------------
// ȱʡɫ
void __fastcall TFrmFace::BtnDefaultColorClick(TObject *Sender)
{
        g_Color = TColor( DEF_COLOR_MON );

        FrmMain->ColorDialog1->Tag = 1;
        ShowStatus("ĻشڵɫָΪȱʡֵ", StatusBar1, 0);
}
//---------------------------------------------------------------------------

