/******************************
 ֹ˾ȫֲã»
 ******************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

int f_cfgcity(void)
{
    int   i, b, nLen;

    char *p,
          szBelong[16],         /* ֹ˾ */
          szCfgFile[256],       /* ļ */

          szLogPath[256],       /* ֹ˾־· */
          szFsnPath[256],       /* ֹ˾· */
          szCfgPath[256];       /* ֹ˾· */

    char *pID,
          szValue[64],
          szBuf[128];

    uid_t uid1;                 /* ֹ˾ID */
    gid_t gid1;

    /* ֹ˾ */
    i = f_seekTAG(TAG_BELONG);
    strcpy(szBelong, u_TAGs[i].pv);

    szCfgPath[0] = 0;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        p = NULL;
        nLen = 0;

        switch( u_TAGs[i].tag )
        {
        case TAG_CFGPATH:    /* Ŀ¼ */
            p = szCfgPath;
            nLen = sizeof(szCfgPath) - 1;
            break;

        case TAG_LOGPATH:    /* ־Ŀ¼ */
            p = szLogPath;
            nLen = sizeof(szLogPath) - 1;
            break;

        case TAG_FSNPATH:    /* Ŀ¼ */
            p = szFsnPath;
            nLen = sizeof(szFsnPath) - 1;
            break;
        }

        if( p )
        {
            /* ȡϢ */
            b = z_readini(CITYS_CFG, u_TAGs[i].key, szBelong, p, nLen, 0);

            if( b )
            {
                z_logv(g_logfile, "key=%s", u_TAGs[i].key);
                GC_sendecode(E_LOGONDENY);
                return(1);
            }
        }
    }

    /* · */
    if( access(szCfgPath, R_OK) )
    {
        GC_sendecode(E_BELONG);
        return(2);
    }

    p = u_cinfo;
    *p = 0;

    // ־·
    f_packTLV(&p, szLogPath, TAG_LOGPATH);

    // ·
    f_packTLV(&p, szCfgPath, TAG_CFGPATH);

    // ·
    f_packTLV(&p, szFsnPath, TAG_FSNPATH);

    snprintf(szCfgFile, sizeof(szCfgFile), "%s/%s%s", szCfgPath, szBelong, CFGSUFFIX);

    switch( u_pkthead.tc )
    {
        case TC_CFGCITY:    /* ļ */

            if( f_updateCFG(szCfgFile, TAGGRP_CITY) < 0 )
            {
                GC_sendecode(E_FILE);
                return(1);
            }

            /* ȡֹ˾ID */
            b = z_readini(CITYS_CFG, SEG_LOGONUSERS, szBelong, szBuf, sizeof(szBuf) - 1, 0);

            if( b )
            {
                GC_sendecode(E_FILE);
                return(1);
            }

            /* ļȨ */
            pID = szBuf;

            z_get_fieldv(&pID, szValue, NULL, sizeof(szValue) - 1, ",");
            uid1 = strtol(szValue, (char **)NULL, 10);

            z_get_fieldv(&pID, szValue, NULL, sizeof(szValue) - 1, ",");
            gid1 = strtol(szValue, (char **)NULL, 10);

            if( chown(szCfgFile, uid1, gid1) < 0 )
            {
                GC_sendecode(E_FILE);
                return(1);
            }

            break;

        case TC_RCFGCITY:   /* ȡԭʼ */

            for( i = 0; i < MAXN_TAG; i++ )
            {
                if( u_TAGs[i].tag == 0 ) break;
                if( u_TAGs[i].group != TAGGRP_CITY ) continue;

                z_getkeyv(szCfgFile, u_TAGs[i].key, u_TAGs[i].pv, u_TAGs[i].vlen);
                f_packTLV(&p, u_TAGs[i].pv, u_TAGs[i].tag);
            }
            break;
    }

    *p = 0;
    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(0);
}
