/****************
 ƽ̨ȫֲ
 ****************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

int f_cfgplat(void)
{
    int   i;

    char *p,
          cEncry = 0,
          szIsEncry[2],     /* Ƿ */
          szPass1[64],      /*  */
          szText1[64];      /*  */

    static char szCmd[1024];

    szText1[0] = 0;
    szIsEncry[0] = 0;
    szPass1[0] = 0;

    p = u_cinfo;
    *p = 0;

    switch( u_pkthead.tc )
    {
        case TC_CFGPLAT:    /* ļ */

            for( i = 0; i < MAXN_TAG; i++ )
            {
                if( u_TAGs[i].tag == 0 ) break;

                switch( u_TAGs[i].tag )
                {
                case TAG_RZENCRYPTION:      /* Ƿ */

                    strcpy(szIsEncry, u_TAGs[i].pv);
                    break;

                case TAG_PASSWORD1:         /*  */

                    strcpy(szText1, u_TAGs[i].pv);
                    break;
                }
            }

            /* TAG */
            if( szIsEncry[0] == '1' )
            {
                memset(szPass1, 0, sizeof(szPass1));
                f_pass_encry(szText1, szPass1);
            }
            else
                strcpy(szPass1, szText1);

            if( f_setTAG(TAG_PASSWORD1, szPass1) < 0 ) return(-1);

            /* дļ */
            if( f_updateCFG(u_szPlatCfg, TAGGRP_PLAT) < 0 )
            {
                GC_sendecode(E_FILE);
                return(1);
            }
            if( chmod(u_szPlatCfg, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH) < 0 )
            {
                GC_sendecode(E_FILE);
                return(1);
            }

            sprintf(szCmd, "%s -c %s -R", u_szPlatHelp, u_szPlatCfg);
            z_logv(g_logfile, szCmd);

            system(szCmd);

            break;

        case TC_RCFGPLAT:   /* ȡԭʼ */

            for( i = 0; i < MAXN_TAG; i++ )
            {
                if( u_TAGs[i].tag == 0 ) break;
                if( u_TAGs[i].group != TAGGRP_PLAT &&
                    u_TAGs[i].group != TAGGRP_PLAT_REP ) continue;

                z_getkeyv(u_szPlatCfg, u_TAGs[i].key, u_TAGs[i].pv, u_TAGs[i].vlen);

                /*  */
                if( u_TAGs[i].tag == TAG_PASSWORD1 )
                {
                    strcpy(szPass1, u_TAGs[i].pv);
                }
                else
                {
                    if( u_TAGs[i].tag == TAG_RZENCRYPTION ) cEncry = *(u_TAGs[i].pv);
                    f_packTLV(&p, u_TAGs[i].pv, u_TAGs[i].tag);
                }
            }

            /*  */
            if( cEncry != '1' )
            {
                strcpy(szText1, szPass1);
            }
            else
            {
                memset(szText1, 0, sizeof(szText1));
                f_pass_decry(szPass1, (unsigned char *)szText1);
            }

            f_packTLV(&p, szText1, TAG_PASSWORD1);

            break;
    }

    *p = 0;
    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(0);
}
