//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "BatchUpdate.h"
#include "BatchFilter.h"
#include "BatchDo.h"
#include "Config.h"             // ô
#include "Fpub.h"               // 
//---------------------------------------------------------------------------

#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmBatchUpdate *FrmBatchUpdate;

//---------------------------------------------------------------------------
__fastcall TFrmBatchUpdate::TFrmBatchUpdate(TComponent* Owner) : TForm(Owner)
{
        // 
        m_szDesc[0] = 0;                        // 
        m_szHost[0] = 0;                        // 
        m_szDstPath[0] = 0;                     // Ŀ·
        m_szFileAnalyzer[0] = 0;                // 
        m_iOperType = 0;                        // 
        m_iSeqCtrl = 0;                         // Ƿϸſ
        memset(m_iCheck, 0, sizeof(m_iCheck));  // Ƿʹ

        // ޸ĸֵ
        u_szHostPair[0] = 0;                    // IP
        u_szPassPair[0] = 0;                    // 
        u_szFileAnalyzer[0] = 0;                // 
        u_szSrcPattern[0] = 0;                  // Դƥģʽ
        u_szDstPath[0] = 0;                     // Ŀ·
        u_szDstNameFormat[0] = 0;               // Ŀתʽ
        u_iBusyItv = 0;                         // æʱɼ
        u_iFreeItv = 0;                         // ʱɼ
        u_iNoLimit = 0;                         // ļ澯ʱ
        u_iExtraCopy = 0;                       // ⿽
        memset(u_iCheck, 0, sizeof(u_iCheck));  // Ƿʹ
}

//---------------------------------------------------------------------------
void __fastcall TFrmBatchUpdate::FormShow(TObject *Sender)
{
        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }
}

//---------------------------------------------------------------------------
void __fastcall TFrmBatchUpdate::BtnFilterCondClick(TObject *Sender)
{
        FrmBatchFilter = new TFrmBatchFilter(this);
        FrmBatchFilter->Font = g_Font;
        FrmBatchFilter->ShowModal();

        delete FrmBatchFilter;
        FrmBatchFilter = NULL;
}

//---------------------------------------------------------------------------
// ִ
void __fastcall TFrmBatchUpdate::BtnFilterClick(TObject *Sender)
{
        int   iLineSeq,                 // 
              iLineSplit,               // вֱ־
              iColSplit;                // вֱ־

        char *pBody,
             *pLine,                    // ָ
             *pCol;                     // ָ

        char  szCol[256],               // ĳһ
              szMore[16],               // ı־
              szVal[64];

        static char szBody[1024],       // 
                    szLine[1024];       // 

        TListItem *pListItem;           // б

        // 䱨ͷ
        m_skt.SetHeadN(TC_BATFILTER, 2);

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))

        pBody = szBody;

        // 
        if( m_iCheck[0] == 1 ) f_packTLV(&pBody, m_szDesc, TAG_DESCRIPTION);

        // 
        if( m_iCheck[1] == 1 ) f_packTLV(&pBody, m_szHost, TAG_HOSTIP1);

        // Ŀ·
        if( m_iCheck[2] == 1 ) f_packTLV(&pBody, m_szDstPath, TAG_DEST_PATH);

        // 
        if( m_iCheck[3] == 1 ) f_packTLV(&pBody, m_szFileAnalyzer, TAG_FILE_ANALYZER);

        // Ƿſ
        if( m_iCheck[4] == 1 )
        {
                sprintf(szVal, "%d", m_iSeqCtrl);
                f_packTLV(&pBody, szVal, TAG_SEQUENCE_CONTROL);
        }

        // 
        if( m_iCheck[5] == 1 )
        {
                sprintf(szVal, "%d", m_iOperType);
                f_packTLV(&pBody, szVal, TAG_OPERATION_TYPE);
        }

        *pBody = 0;
//---------------------------------------------------------------------------

        // жȡ
        iLineSeq = EditTotal->Text.ToInt();

        // 2̨󣬲ȡӦ
        for( int k = 0; k < 2; k++ )
        {
                if( SktComm(m_skt, k + 1, szBody, StatusBar1, 0) ) return;

                // ѭȡӦ
                szMore[0] = '1';

                while( szMore[0] == '1' )
                {
                        if( JustRead(m_skt, StatusBar1, 0, 0) != R_OK ) break;

                        pLine = m_skt.GetReply() + m_skt.GetHeadLen();

                        do {
                                iLineSplit = GC_get_fieldv(&pLine, szLine, NULL, sizeof(szLine) - 1, D_LINE);
                                if( szLine[0] == 0 ) break;

                                pListItem = ListView1->Items->Add();
                                pListItem->Checked = true;
                                pListItem->Caption = IntToStr(iLineSeq + 1);
                                pListItem->SubItems->Add(IntToStr(k + 1));

                                // ָ
                                pCol = szLine;

                                do {
                                        iColSplit = GC_get_fieldv(&pCol, szCol, NULL, sizeof(szCol) - 1, D_COL);
                                        pListItem->SubItems->Add(szCol);
                                }
                                while( iColSplit );

                                iLineSeq ++;
                        }
                        while( iLineSplit );

                        // ı־
                        m_skt.GetHeadN(szMore, 4);
                }
                m_skt.Close();
        }

        ShowStatus("Ok", StatusBar1);
        ListView1->SetFocus();
        EditTotal->Text = IntToStr( iLineSeq );
}

//---------------------------------------------------------------------------
// ʾϢ
void __fastcall TFrmBatchUpdate::ListView1SelectItem(TObject *Sender,
      TListItem *Item, bool Selected)
{
        char *pHost, *pName, *pNo;

        if( ListView1->SelCount <= 0 ) return;

        // 
        pHost = ListView1->Selected->SubItems->Strings[0].c_str();
        // û
        pName = ListView1->Selected->SubItems->Strings[1].c_str();
        // ɼ
        pNo = ListView1->Selected->SubItems->Strings[2].c_str();

        ListView1->Hint = "" + ListView1->Selected->Caption + "    "
                        + "" + pHost + "    "
                        + "ֹ˾" + pName + "    "
                        + "" + pNo;
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmBatchUpdate::BtnClearClick(TObject *Sender)
{
        ListView1->Items->Clear();
        EditTotal->Text = "0";
}

//---------------------------------------------------------------------------
// ָ޸ĵĸֵʾ
void __fastcall TFrmBatchUpdate::BtnUpdateExprClick(TObject *Sender)
{
        FrmBatchDo = new TFrmBatchDo(this);
        FrmBatchDo->Font = g_Font;
        FrmBatchDo->ShowModal();

        delete FrmBatchDo;
        FrmBatchDo = NULL;
}

//---------------------------------------------------------------------------
// ޸
void __fastcall TFrmBatchUpdate::BtnUpdateClick(TObject *Sender)
{
        TListItem *pListItem;           // б

        int    b = 0;

        char  *pBody,
              *pBodyPub,
              *pHost, *pName, *pNo,
               szVal[64];

        static char szBody[1024];       // 

        for( int i = 0; i < sizeof(u_iCheck) / sizeof(int); i++ )
        {
                if( u_iCheck[i] == 1 )
                {
                        b = 1;
                        break;
                }
        }

        if( b == 0 )
        {
                ErrDlg("δָ޸߼");
                return;
        }

        // 䱨ͷ
        m_skt.SetHeadN(TC_BATUPDATE, 2);

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))

        pBody = szBody;

        // IP
        if( u_iCheck[0] == 1 ) f_packTLV(&pBody, u_szHostPair, TAG_HOSTIP_PAIR);

        // 
        if( u_iCheck[1] == 1 ) f_packTLV(&pBody, u_szPassPair, TAG_PASSWORD_PAIR);

        // 
        if( u_iCheck[2] == 1 ) f_packTLV(&pBody, u_szFileAnalyzer, TAG_FILE_ANALYZER);

        // Դƥģʽ
        if( u_iCheck[3] == 1 ) f_packTLV(&pBody, u_szSrcPattern, TAG_SRC_PATTERN);

        // Ŀ·
        if( u_iCheck[4] == 1 ) f_packTLV(&pBody, u_szDstPath, TAG_DEST_PATH);

        // Ŀתģʽ
        if( u_iCheck[5] == 1 ) f_packTLV(&pBody, u_szDstNameFormat, TAG_DEST_NAME_FORMAT);

        // æʱɼ
        if( u_iCheck[6] == 1 )
        {
                sprintf(szVal, "%d", u_iBusyItv);
                f_packTLV(&pBody, szVal, TAG_BUSY_INTERVAL);
        }

        // ʱɼ
        if( u_iCheck[7] == 1 )
        {
                sprintf(szVal, "%d", u_iFreeItv);
                f_packTLV(&pBody, szVal, TAG_FREE_INTERVAL);
        }

        // ޻澯ʱ
        if( u_iCheck[8] == 1 )
        {
                sprintf(szVal, "%d", u_iNoLimit);
                f_packTLV(&pBody, szVal, TAG_NOFILE_LIMIT);
        }

        // ⿽
        if( u_iCheck[9] == 1 )
        {
                sprintf(szVal, "%d", u_iExtraCopy);
                f_packTLV(&pBody, szVal, TAG_EXTRACOPY);
        }

        *pBody = 0;
        pBodyPub = pBody;
//---------------------------------------------------------------------------

        MemoReport->Lines->Clear();
        for( int i = 0; i < ListView1->Items->Count; i++ )
        {
                pListItem = ListView1->Items->Item[i];
                if( pListItem->Checked == true )
                {
                        // 
                        pHost = pListItem->SubItems->Strings[0].c_str();
                        // û
                        pName = pListItem->SubItems->Strings[1].c_str();
                        // ɼ
                        pNo = pListItem->SubItems->Strings[2].c_str();

                        pBody = pBodyPub;
                        f_packTLV(&pBody, pName, TAG_BELONG);
                        f_packTLV(&pBody, pNo, TAG_NO);
                        *pBody = 0;

                        b = SktComm(m_skt, StrToInt(pHost), szBody, StatusBar1);

                        if( b == R_OK )
                                MemoReport->Lines->Add(String(pNo) + "... Ok");
                        else
                                MemoReport->Lines->Add(String(pNo) + "... Failed");
                }
        }
}

//---------------------------------------------------------------------------
// 
void __fastcall TFrmBatchUpdate::BtnCheckClick(TObject *Sender)
{
        char *pHost, *pName, *pNo;

        if( ListView1->SelCount <= 0 ) return;

        // 
        pHost = ListView1->Selected->SubItems->Strings[0].c_str();
        // û
        pName = ListView1->Selected->SubItems->Strings[1].c_str();
        // ɼ
        pNo = ListView1->Selected->SubItems->Strings[2].c_str();

        FrmConfig = new TFrmConfig(this);
        FrmConfig->Font = g_Font;

        FrmConfig->EditBelong->Text = pName;
        FrmConfig->EditNo->Text = pNo;
        FrmConfig->Tag = StrToInt(pHost);

        // ðť
        FrmConfig->BtnStart->Enabled = false;
        FrmConfig->BtnCheck->Enabled = false;
        FrmConfig->BtnUpLoad->Enabled = false;
        //FrmConfig->BtnStart->Visible = false;

        FrmConfig->ShowModal();

        delete FrmConfig;
        FrmConfig = NULL;

        ListView1->SetFocus();
}

//---------------------------------------------------------------------------
// ȫѡ
void __fastcall TFrmBatchUpdate::ChkBoxAllClick(TObject *Sender)
{
        TListItem * pListItem;           // б

        if( ChkBoxAll->Checked == true )
        {
                ChkBoxAllNot->Checked = false;
                for( int i = 0; i < ListView1->Items->Count; i++ )
                {
                        pListItem = ListView1->Items->Item[i];
                        pListItem->Checked = true;
                }
        }
}

//---------------------------------------------------------------------------
// ȫѡ
void __fastcall TFrmBatchUpdate::ChkBoxAllNotClick(TObject *Sender)
{
        TListItem * pListItem;           // б

        if( ChkBoxAllNot->Checked == true )
        {
                ChkBoxAll->Checked = false;
                for( int i = 0; i < ListView1->Items->Count; i++ )
                {
                        pListItem = ListView1->Items->Item[i];
                        pListItem->Checked = false;
                }
        }
}

//---------------------------------------------------------------------------
// ݣ
void __fastcall TFrmBatchUpdate::Button1Click(TObject *Sender)
{
        int   iLineSeq;                 // 

        TListItem * pListItem;          // б

        // ʾ
        iLineSeq = EditTotal->Text.ToInt();

        for( int i = 1; i < 300; i++, iLineSeq++ )
        {
                pListItem = ListView1->Items->Add();
                pListItem->Checked = true;
                pListItem->Caption = IntToStr(iLineSeq + 1);
                pListItem->SubItems->Add(IntToStr(1));

                if( i % 2 == 0 )
                {
                        pListItem->SubItems->Add("tbcs");
                        pListItem->SubItems->Add("vtbcs");
                }
                else
                {
                        pListItem->SubItems->Add("dev20");
                        pListItem->SubItems->Add("vt1");
                }

                pListItem->SubItems->Add("");
                pListItem->SubItems->Add("");
                pListItem->SubItems->Add("10.164.129.21,10.164.129.21");
                pListItem->SubItems->Add("tbcsdev,tbcsdev");
                pListItem->SubItems->Add("analyvpmn");
                pListItem->SubItems->Add("bbb????.dat");
                pListItem->SubItems->Add("/raw3/hz/HZ10");
                pListItem->SubItems->Add("HZ10.@");
                pListItem->SubItems->Add("30");
                pListItem->SubItems->Add("60");
                pListItem->SubItems->Add("-1");
                pListItem->SubItems->Add("1");
        }

        ListView1->SetFocus();
        EditTotal->Text = IntToStr( iLineSeq );
}

//---------------------------------------------------------------------------
// ֹͣ/ͨťTag Կ
void __fastcall TFrmBatchUpdate::BtnBatStopClick(TObject *Sender)
{
        TListItem *pListItem;           // б

        int    b = 0,
               iOnOff;

        char  *pBody,
              *pHost, *pName, *pNo,
               szBody[256];             // 

        // 䱨ͷ
        if( static_cast<TButton *>(Sender)->Tag == 1 )
                iOnOff = 1;
        else
                iOnOff = 0;

        if( iOnOff == 1 )
                m_skt.SetHeadN(TC_START, 2);
        else
                m_skt.SetHeadN(TC_STOP, 2);

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))

        MemoReport->Lines->Clear();
        for( int i = 0; i < ListView1->Items->Count; i++ )
        {
                pListItem = ListView1->Items->Item[i];
                if( pListItem->Checked == true )
                {
                        // 
                        pHost = pListItem->SubItems->Strings[0].c_str();
                        // û
                        pName = pListItem->SubItems->Strings[1].c_str();
                        // ɼ
                        pNo = pListItem->SubItems->Strings[2].c_str();

                        pBody = szBody;
                        f_packTLV(&pBody, pName, TAG_BELONG);
                        f_packTLV(&pBody, pNo, TAG_NO);
                        *pBody = 0;

                        if( iOnOff == 0 )       // ֹͣ
                        {
                                b = SktComm(m_skt, StrToInt(pHost), szBody, StatusBar1, 0);
                                // ̽ӦϢʾ
                                if( b == R_OK ) b = ReadProgress(m_skt, this, StatusBar1);
                        }
                        else
                                b = SktComm(m_skt, StrToInt(pHost), szBody, StatusBar1);

                        if( b == R_OK )
                                MemoReport->Lines->Add(String(pNo) + "... Ok");
                        else
                                MemoReport->Lines->Add(String(pNo) + "... Failed");
                }
        }
}

//---------------------------------------------------------------------------
// ˢ״̬
void __fastcall TFrmBatchUpdate::BtnStatRefClick(TObject *Sender)
{
        TListItem *pListItem;           // б

        char  *pBody,
              *pHost, *pName, *pNo,
               szBody[256];             // 

        // 䱨ͷ
        m_skt.SetHeadN(TC_STATGET, 2);

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))

        MemoReport->Lines->Clear();
        for( int i = 0; i < ListView1->Items->Count; i++ )
        {
                pListItem = ListView1->Items->Item[i];
                if( pListItem->Checked == true )
                {
                        // 
                        pHost = pListItem->SubItems->Strings[0].c_str();
                        // û
                        pName = pListItem->SubItems->Strings[1].c_str();
                        // ɼ
                        pNo = pListItem->SubItems->Strings[2].c_str();

                        pBody = szBody;
                        f_packTLV(&pBody, pName, TAG_BELONG);
                        f_packTLV(&pBody, pNo, TAG_NO);
                        *pBody = 0;

                        if( SktComm(m_skt, StrToInt(pHost), szBody, StatusBar1) == R_OK )
                        {
                                m_skt.GetHeadN(szBody, 5);         // ״̬
                                pListItem->SubItems->Strings[3] = szBody;
                        }
                        else
                                MemoReport->Lines->Add(String(pNo) + "... Failed");
                }
        }
}
//---------------------------------------------------------------------------

