#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "zvar.h"
#include "gcps.h"
#include "z.h"

/****************************
 
 ڲchar *pno ̱
 ****************************/
int f_oncheck(char *pno)
{
    int   b, k, fauth;
    char  vno[16], authfile[CL], szValue[64];

    uid_t authuid = 0, myuid;

    if( pno )
    {
        /* Ȩļ */
        if( z_getkeyv(g_cfgfile, AUTHFILE, authfile, sizeof(authfile) - 1) )
            return(0);

        fauth = f_authinfo(authfile, pno, NULL, &authuid);

        if( fauth != 2 && (fauth != 1 || authuid != geteuid()) )
        {
            printf("\nȨɼ %s\n\n", pno);
            return(-1);
        }
    }
    else
    {
        if( z_getkeyv(g_cfgfile, "USER_SHM_LEN", szValue, sizeof(szValue) - 1) )
        {
            printf("ƽ̨ļڴС USER_SHM_LEN !\n");
            return(-1);
        }

        k = ZPUB_LEN + (MAXN_Z * ZCFG_LEN) + (MAXN_Z * ZRUN_LEN);
        b = (int) strtol(szValue, (char **)NULL, 10);

        if( b < k )
        {
            printf("ƽ̨ļ USER_SHM_LEN !\n");
            return(-1);
        }

        authuid = -1;
        myuid = geteuid();

        if( z_getkeyv(g_cfgfile, "STARTUID", vno, sizeof(vno) - 1) == 0 )
            authuid = (int) strtol(vno, (char **)NULL, 10);

        if( authuid == 0 )
        {
            if( myuid )
            {
                printf("\n󣺱rootƽ̨\n");
                return(-1);
            }
        }
        else if( authuid > 0 )
        {
            if( myuid != authuid )
            {
                printf("\nݲû(%ld) ƽ̨\n", (long)authuid);
                return(-1);
            }
        }
    }

    return(0);
}

/**************************************
 ȡָɼûȨϢ
 ڲchar  *pfile  ļ
           char  *pno    ɼ
           char  *pname  û
           uid_t *puid   ûID
 ֵ  0   Ų
           1   ɹ
           2   Ȩ
 **************************************/
int f_authinfo(char *pfile, char *pno, char *pname, uid_t *puid)
{
    int   b;
    char *p, szBuf[128], szName[64], szUid[32];

    b = z_readini(pfile, SG_AUTH_BEG, pno, szBuf, sizeof(szBuf) - 1, 0);

    switch( b )
    {
    case 0:
        b = 1;

        p = szBuf;
        z_get_fieldv(&p, szUid, NULL, sizeof(szUid) - 1, ",");
        z_get_fieldv(&p, szName, NULL, sizeof(szName) - 1, ",");

        if( pname ) strcpy(pname, szName);
        if( puid ) *puid = strtol(szUid, (char **)NULL, 10);
        break;

    case -1:
        b = 0;
        break;

    case -2:
        b = 2;
        break;

    case 3:
        b = 0;
        break;
    }

    return(b);
}
