/****************************
 BOSS1.5 ҵ
 ****************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gcps.h"
#include "z.h"
#include "mo15.h"
#include "base.h"
#include "DataSet.h"
//#include "TUX_BkUniCall.h"
//#include "SrvCall.h"
#include "IntSrv.h"
#include "BaseIntPkg.h"
#include  "RequestContext.h"

int CallTuxedo(CBaseIntPkg &pkg, const char *TuxSvrAddr, const char *TuxSvrName, const char *TuxSvrRegion, char *msg) ;

/***************************
 ֵ   0 ɹ
            1 ޶
           -1 CICS
           -2 ݿ
           -3 ϵͳ
 ***************************/
int call15(SMRULE *prule, SMREQ *qd)
{
    int   i, j, r, b,
          rows, cols, nlist;

    char *p, (*pmidcols)[65] = NULL,
          colstr[8], ecode[8], emsg[256], sendornot[8];

    char  vname[65], vout[513], commandid[33], menuid[33];

    static char buf1[1024];

    CBaseIntPkg pkg;

/* ------------------------------------------------- */
    /* ·ɲ */
    strcpy(pkg.strIntID, "IntSms");
    strcpy(pkg.strOperator, "IntSms");
    strcpy(pkg.strTelnum, qd->TELNUM);
    strcpy(pkg.strIntCmd, prule->opcode);
    pkg.transFlag = 1;

//	RCSetAccessType("bsacSms");
	
		RCSetAccessInfo("bsacSms", "bsacSms", "");

    CTagSet *in = new CTagSet;

    pkg.m_inParams.Add(in);
    memset(commandid, 0, sizeof(commandid));
    memset(menuid, 0, sizeof(menuid));

    /* SetValue */
    for( i = 0; i < MAXTAGS && u_tagvalue[i].tag[0]; i++ )
    {
        in->SetValue(u_tagvalue[i].tag, u_tagvalue[i].value);
        if( 0 == strcmp(u_tagvalue[i].tag,"COMMANDID") ) 
        {
            strcpy(commandid, u_tagvalue[i].value);
            sprintf(menuid, "CMD:%s", commandid);
        }
        else if( 0 == strcmp(u_tagvalue[i].tag,"NCODE") ) 
        {
            strcpy(commandid, u_tagvalue[i].value);
            sprintf(menuid, "NCD:%s", commandid);
        }
            
    }
    strcpy(pkg.strMenuID, menuid);
    strcpy(pkg.strIntSubCmd, commandid);
    in->SetValue("UniContactFlag", "2");
    in->SetValue("RELATEDFORMNUM",qd->FORMNUM);
    z_logv(u_logfile, "menuid=%s", menuid);

 
    /* ÷ */
    try
    {
        char retmsg[1024] = {0};
        char region[5] = {0};
        int iRet = 0;
        u_gettag("REGION", region, PARA_ALL);
        strcpy(pkg.strRegion, region);
        iRet = CallTuxedo( pkg, TuxSvrAddr, TuxSvrName, region, retmsg);
        z_logv(u_logfile, "񷵻ֵ[%d]Ϣ[%s]", iRet, retmsg);
        if(iRet < 0 ) 
        {
            if(strstr(retmsg, "no entry found")>0)
            {
                return(-5);
            }
            u_settag("RETCODE", CODE_CICSFAIL, TEXT_T_NORMAL, PARA_RKEY);
            u_settag("RETMSG", retmsg, TEXT_T_NORMAL, PARA_RKEY);
            return(-4);
        }
    }
    catch(EProtocol &e)
    {
        z_logsetonly1(1);
        z_logv(u_logfile, e.Message);
        u_settag("RETCODE", CODE_CICSFAIL, TEXT_T_NORMAL, PARA_RKEY);
        u_settag("RETMSG", e.Message, TEXT_T_NORMAL, PARA_RKEY);
        if( strstr(e.Message, "") ) sleep(30);
        return(-4);
    }
    catch(ECustom &e)
    {
        z_logsetonly1(1);
        z_logv(u_logfile, e.Message);
        u_settag("RETCODE", CODE_CICSFAIL, TEXT_T_NORMAL, PARA_RKEY);
        u_settag("RETMSG", e.Message, TEXT_T_NORMAL, PARA_RKEY);
        return(-1);
    }
    catch(...)
    {
        z_logv(u_logfile,"мδ֪쳣");
        return(-1);
    }

/* ----------------------------------------------------------------- */
    /* ȡӦϢ */
    if( (r = pkg.m_outParams.GetSize()) == 0 )
    {
        z_logv(u_logfile, "ûзϢ");
        return(-1);
    }

    z_logv(u_logfile, "Ok, GetSize=%d", r);

    CTagSet *out  = NULL;
    CRSet   *out1 = NULL;

    for( i = 0; i < r; i++ )
    {
        if( out == NULL ) out = dynamic_cast <CTagSet *> (pkg.m_outParams.Get(i));
        if( out1 == NULL ) out1 = dynamic_cast <CRSet *> (pkg.m_outParams.Get(i));
    }
    z_logv(u_logfile, "out=%p, out1=%p", out, out1);

/* ------------------------------------------------- */
    /* ȡֵ */
    memset(ecode, 0, sizeof(ecode));
    memset(emsg, 0, sizeof(emsg));

    if( out )
    {

        for( j = 0; j < out->Count(); j++ )
        {
            char *tag = NULL, *value = NULL;

            tag   = (char *) (*out)[j]->Tag.c_str();
            value = (char *) (*out)[j]->Value.EntityString;
            if(u_writelog >= 1) z_logv(u_logfile, "[TRACE] tag=%s, value=%s", tag, value);

            if( strcmp(tag, "RETCODE") == 0 )           // ش
            {
                strncpy(ecode, value, sizeof(ecode) - 1);
                ecode[ sizeof(ecode) - 1 ] = 0;
                u_settag(tag, value, TEXT_T_NORMAL, PARA_RKEY);
            }
            else  if( strcmp(tag, "REALRETCODE") == 0 )           // ش
            {
                strncpy(ecode, value, sizeof(ecode) - 1);
                ecode[ sizeof(ecode) - 1 ] = 0;
                u_settag(tag, value, TEXT_T_NORMAL, PARA_RKEY);
            }
            else if( strcmp(tag, "RETMSG") == 0 )       // Ϣ
            {
                strncpy(emsg, value, sizeof(emsg) - 1);
                emsg[ sizeof(emsg) - 1 ] = 0;
                u_settag(tag, value, TEXT_T_NORMAL, PARA_RKEY);
            }
            else if( strcmp(tag, "SENDORNOT") == 0 )    // ǷѷͶ
            {
                strncpy(sendornot, value, sizeof(sendornot) - 1);
                sendornot[ sizeof(sendornot) - 1 ] = 0;

                u_settag(tag, value, TEXT_T_NORMAL, PARA_RKEY);
            }

            if( u_gettag(tag, NULL, PARA_RKEY) >= 0 )
                u_settag(tag, value, TEXT_T_NORMAL, PARA_RKEY);
        }
    }

    z_lrtrim(ecode);
    z_lrtrim(emsg);

    /*  */
    strcpy(prule->retcode, ecode);

    /* ֵ */
    r = u_cal_para(prule, PARA_RKEY);

    //z_logv(u_logfile, "RETCODE=%s, RETMSG=%s, SENDORNOT=%d, TEMPLATENO=%s, TEMPLATEPARA=%s", ecode, emsg, prule->sendornot,out->GetValue("TEMPLATENO"),out->GetValue("TEMPLATEPARA"));

    if( r < 0 ) return(-3);

    if( prule->sendornot == 1 ) return(0);

    /* ʾ_RS */
    u_rset[0] = 0;

    if( out1 == NULL ) rows = 0;
    else rows = out1->Rows();

    if(u_writelog >= 1) z_logv(u_logfile, "[TRACE] rows=%d, prule->startrow=%d", rows,prule->startrow);

    /* ȡ */
    r = u_read_rsfmt(prule);

    if( r < 0 ) return(-2);
    else if( r == 1 ) return(1);

    if(out1 &&  rows <= prule->startrow ) return(0);    /* ޼¼ */

    if( u_gen_rset(prule, out1, rows - prule->startrow, u_rset) < 0 ) return(-3);

    if( out1 )
    {
        /* м */
        if( prule->colmid[0] &&
            strcasecmp(prule->ruletype, RULE_T_IN) == 0 )
        {
            cols = 0;
            p = prule->colmid;

            do {
                r = z_get_fieldv(&p, colstr, NULL, 2, ",");
                cols ++;
            } while( r );

            z_logv(u_logfile, "[TRACE] midcols=%d", cols);

            if( cols == 0 ) return(0);

            pmidcols = (char (*)[65]) malloc((rows - prule->startrow) * cols * 65);
            if( pmidcols == NULL ) return(-3);

            /* ȡмֵ */
            u_get_midcols(prule, out1, pmidcols, rows - prule->startrow);

            if( u_in_mid(qd, rows - prule->startrow, cols, pmidcols) )
            {
                free(pmidcols);
                return(-2);
            }

            free(pmidcols);
        }
    }

    return(0);
}

/*TUXEDO*/
int CallTuxedo(CBaseIntPkg &pkg, const char *TuxSvrAddr, const char *TuxSvrName, const char *TuxSvrRegion, char *msg)
{
	//ӿڷ
   	//CBkUniCall srvcall(TuxSvrRegion,TuxSvrName);
    try
    {
        //z_logv(u_logfile, "CallTuxedo TuxSvrRegion[%s] TuxSvrName[%s]\n", TuxSvrRegion, TuxSvrName);
    	  //жϴ
    
/*
        if(!srvcall.Open(TuxSvrAddr))
        {
            z_logv(u_logfile, "Connect tuxedo failure!\n");
            return(-1);
        }
*/

        //srvcall.Invoke( pkg);
        CBkUniCall iClt_Call(TuxSvrRegion, TuxSvrName);
        iClt_Call.Open(TuxSvrAddr);
        iClt_Call.Invoke(pkg);
    }
    catch(EUniCall &e1)
    {
	      sprintf(msg,  "Exception EUniCall retcode=%d,  retmsg=:%s\n",e1.ErrNo, e1.Message);
		    z_logv(u_logfile, msg);
        //srvcall.Close();
		    return(-2);
	  }
/*
	  catch(ETuxedo &e)
    {
	     sprintf(msg,  "Exception ECustom retmsg=:%s\n", e.Message);
		   //z_logv(u_logfile, msg);
       //srvcall.Close();
		   return(-3);
    }
*/
	  catch(ECustom &e)
	  {
	      sprintf(msg,  "Exception ECustom retmsg=:%s\n", e.Message);
		    //z_logv(u_logfile, msg);
        //srvcall.Close();
		    return(-3);
	  }
     catch (EProtocol &eci) {
        z_logv(u_logfile, "retcode=%d,  retmsg=:%s\n", eci.ErrNo, eci.Message);
        return (-4);
	  }
	  catch(...)
	  {
		    z_logv(u_logfile, "Other Error !\n");
		    strcpy(msg, "Other Error !\0");
        //srvcall.Close();
		    return(-5);
	  }
    //srvcall.Close();
    return(0);
}
