/***********************************************************************
*
* ļ        TmpLog.cpp
* ģĿģ¼ʱ־CLogFileʵ֣
* ߼ڣ  wang_jin 2008-05-08
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "Common/Common.h"
#include "FileOpt/FileOpt.h"
#include "GDLock/GDLock.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"
#include "GDLog/TmpLog.h"

#ifdef _WIN32
#	include <windows.h>
#endif
#include <time.h>
#include <stdarg.h>

CLogFile* CTmpLog::m_pLog = NULL;
bool CTmpLog::m_bLog = true;


bool CTmpLog::InitLog( const char* sFilePath, const char* sFileName, bool bScroll, int nSize, int nCount )
{
	if ( m_pLog )
	{
		delete m_pLog;
	}
	m_pLog = new CLogFile( sFilePath, sFileName, bScroll, nSize, nCount );

	if ( m_pLog )
	{
		return true;
	}
	return false;
}

bool CTmpLog::WriteLog( const char* fmt, ... )
{
	va_list args;
	va_start( args, fmt );
	bool bRet = WriteLog2( fmt, args );
	va_end( args );
	return bRet;
}

bool CTmpLog::WriteLog2( const char* fmt, va_list args )
{
	if ( !m_bLog ) return true;

	bool bRet = false;
	if ( ! m_pLog )
	{
#ifdef WIN32
		char sPath[] = "c:\\tmp";
#else
		char sPath[] = "/tmp";
#endif
		InitLog( sPath );
	}
		
	if ( m_pLog )
	{
		bRet = m_pLog->WriteFile( "", fmt, args );
	}
	
	return bRet;
}
