/**************
 FTAMЭ飬ɼ
 **************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <sys/stat.h>
#include <glob.h>
#include "gcps.h"
#include "z.h"
#include "zvar.h"
#include "ftamapi.h"

#define   LCFS         "ANON"                   /* FileStore */
#define   DOCTYPE      "FTAM-3"                 /* ļ */

int ftam_fget(char *infile, char *outfile, int delflag);

/*********************************
 ڲint *iseq  ǰļ
 ֵ  0    ɹ
           1    ȫ
           -1   ʧ
           -2   FTAMʧ
           -3   ʧ
 *********************************/
int ftam_do(int *iseq)
{
    FILE  *pipefp;

    int    i, b, r,
           f_err = 0,
           getret = 0;                          /* ȡļķֵ */

    long   fsize;                               /* ļС */
    static int mid0num = 0;                     /* ļĿ */

    char  *ppat, pattern[65],                   /* Դļģʽ */
           seqstr[17],                          /* ǰŵַʾ */
           tmstr[20],
           fragfile[CL],                        /* ػƬļ */

           rfname[CL],                          /* Զļ(·) */
           lfname[CL],                          /* ļ(·) */
           midfile[CL], currfile[CL],           /* ļ */
           dtpath[CL],                          /* תڸʽ· */
          *pDstPath,

           zout[CL],                            /* FTP Ϣļ */
           hdftime[21],                         /* ʱ */
           emsg[EMSG_LEN + 1],                  /* ־Ϣ */
           buf1[CL];

    struct stat  statbuf;

    /*  FTAM ʱʱ */
    tpi_timeout(u_zcfg.ftp_timeout);

    /* ӽ */
    if( (r = ftiapi_connect(LCFS, u_zcfg.host[0], u_zcfg.user[0], u_zcfg.pass[0], 1, 2)) )
    {
        z_logv(u_logfile, "ӷ=%d", r);

        if( r == R_LICENSE )
        {
            sprintf(emsg, "License ֤ʧ");
            f_seterr(emsg, "A100", "APP", 9);
            return(R_RESTART);
        }

        if( (b = ftiapi_getremoteerror()) ) 0;
        else if( (b = ftiapi_getlocalerror()) ) 0;
        else b = r + 100;

        z_logv(u_logfile, "=%d", b);

        /*  */
        /*
         * if( u_zcfg.host[1][0] && f_ping(u_zcfg.host[1]) < 0 )
         *     sprintf(emsg, "ڵ'%s'", u_zcfg.host[1]);
         * else
         *     sprintf(emsg, "¼ʧ=%d", b);
         */

        sprintf(emsg, "¼ʧ=%d", b);
        f_seterr(emsg, "N001", "NET", 6);

        return(R_RESTART);
    }

    z_logv(u_logfile, " OK");
/* ---------------------------------------------------------- */

    /* Զļģʽ */
    if( u_zcfg.seq_ctrl == 1 )                  /* Ź */
    {
        sprintf(seqstr, "%0*d", u_zcfg.seq_length, *iseq);
        f_seq2name(seqstr, pattern);

        ppat = pattern;
    }
    else if( u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
    {
        f_seq2name(NULL, pattern);
        ppat = pattern;
    }
    else
        ppat = u_zcfg.src_fn_pattern;

    strcpy(rfname, ppat);

    /* Ŀļ */
    if( (b = f_nametr(rfname, u_zcfg.dst_format, lfname)) < 0 )
    {
        sprintf(emsg, "'%s' Ŀתʧ=%d", u_zcfg.dst_format, b);
        f_seterr(emsg, "A010", "APP", 9);

        f_err = -3;
        goto FTAM_END;
    }

    /* ڸʽĿ· */
    if( strchr(u_zcfg.dst_path, SM_PATH_DATE) )
    {
        if( f_dtpath_local(u_zcfg.dst_path, dtpath) < 0 )
        {
            f_seterr("Ŀ·ʧ", "A011", "APP", 9);
            f_err = -3;
            goto FTAM_END;
        }

        pDstPath = dtpath;
        snprintf(currfile, sizeof(currfile), "%s/%s", dtpath, lfname);
        snprintf(midfile, sizeof(midfile), "%s/tmp.%s.tmp", dtpath, lfname);
    }
    else
    {
        pDstPath = u_zcfg.dst_path;
        snprintf(currfile, sizeof(currfile), "%s/%s", u_zcfg.dst_path, lfname);
        snprintf(midfile, sizeof(midfile), "%s/tmp.%s.tmp", u_zcfg.dst_path, lfname);
    }

    z_logv(u_logfile, "Remote=%s", rfname);
    z_logv(u_logfile, "Local=%s", lfname);

    /* ⿽· */
    for( i = 0; i < u_zcfg.extracopy; i++ )
    {
        snprintf(buf1, sizeof(buf1), "%s/%s%d", pDstPath, COPYPREFIX, i + 1);

        if( stat(buf1, &statbuf) < 0 && mkdir(buf1, NEWDIRMODE) < 0 )
        {
            f_seterr("⿽·ʧ", "A011", "APP", 9);
            f_err= -3;
            goto FTAM_END;
        }
    }

/* ---------------------------------------------------------- */

    /* 鿴ļǷѴڣҴС0 */
    memset(&statbuf, 0, sizeof(statbuf));

    if( stat(currfile, &statbuf) == 0 && statbuf.st_size )
    {
        snprintf(emsg, sizeof(emsg), "ļѴڣҴС0%s", currfile);
        f_seterr(emsg, "A012", "APP", 9);

        f_err = -3;
        goto FTAM_END;
    }

    /* 鿴мļǷѴڣҴС0 */
    memset(&statbuf, 0, sizeof(statbuf));

    if( (stat(midfile, &statbuf) == 0) && statbuf.st_size )
    {
        z_get_dt(tmstr, 14, "f", 0);
        snprintf(fragfile, sizeof(fragfile), "%s/FRAG.%s.%s", u_zcfg.dst_path, tmstr, seqstr);

        if( rename(midfile, fragfile) < 0 )
        {
            snprintf(emsg, sizeof(emsg), "ļʧܣ%s -> %s", midfile, fragfile);
            f_seterr(emsg, "O003", "OS", 9);

            f_err = -3;
            goto FTAM_END;
        }
        z_logv(u_logfile, "%s -> %s ļ OK.", midfile, fragfile);
    }

    /* ϴβɼʼʱ */
    u_pruns->begtime = time( (time_t *) 0 );

    gettimeofday(&(u_pNidNormal->tStartTv), NULL);

    /* ɼļ */
    getret = ftam_fget(rfname, midfile, 0);

    if( getret == 0 )   /* ɹ */
    {
        gettimeofday(&(u_pNidNormal->tEndTv), NULL);

        /* 鿴мļС */
        memset(&statbuf, 0, sizeof(statbuf));

        if( stat(midfile, &statbuf) < 0 )
        {
            strcpy(emsg, "鿴мļ״̬ʧ");
            f_seterr(emsg, "O004", "OS", 9);

            f_err = -3;
            goto FTAM_END;
        }
        fsize = statbuf.st_size;

        /* ʱ */
        memset(hdftime, 0, sizeof(hdftime));

        if( u_zcfg.file_analyzer[0] && fsize )
        {
            z_logv(u_logfile, "Analyzing ...");
            snprintf(buf1, sizeof(buf1), "%s/%s %s", u_plugdir, u_zcfg.file_analyzer, midfile);

            if( (pipefp = popen(buf1, "r")) )
            {
                fgets(hdftime, sizeof(hdftime), pipefp);
                pclose(pipefp);
            }
        }

        if( rename(midfile, currfile) < 0 )
        {
            snprintf(emsg, sizeof(emsg), "ļ%s -> %s", midfile, currfile);
            f_seterr(emsg, "O003", "OS", 9);

            f_err = -3;
            goto FTAM_END;
        }

        /* link⿽ */
        for( i = 0; i < u_zcfg.extracopy; i++ )
        {
            snprintf(buf1, sizeof(buf1), "%s/%s%d/%s", pDstPath, COPYPREFIX, i + 1, lfname);
            unlink(buf1);

            if( link(currfile, buf1) < 0 )
            {
                f_seterr("Ӷ⿽ļʧ", "A011", "APP", 9);
                f_err= -3;
                goto FTAM_END;
            }
        }

        /* 鿴ļС */
        memset(&statbuf, 0, sizeof(statbuf));

        if( stat(currfile, &statbuf) < 0 )
        {
            snprintf(emsg, sizeof(emsg), "ļʧ%s", currfile);
            f_seterr(emsg, "O005", "OS", 9);

            f_err = -3;
            goto FTAM_END;
        }
        if( fsize != statbuf.st_size )
        {
            snprintf(emsg, sizeof(emsg), "ļ%s", currfile);
            f_seterr(emsg, "O005", "OS", 9);

            f_err = -3;
            goto FTAM_END;
        }

        /* 澯Ϣ */
        emsg[0] = 0;

        if( fsize )
        {
            mid0num = 0;
        }
        else
        {
            mid0num ++;

            if( u_zcfg.warn_mode[WF_ZERO] == '1' )
            {
                sprintf(emsg, "棺ļСΪ0Ŀ%d", mid0num);
                z_logv(u_logfile, emsg);
                f_setnid(emsg, "A018", "APP", 9);
            }
        }

        /* ļ */
        if( u_zcfg.seq_ctrl == 1 )
        {
            if( *iseq < u_zcfg.seq_max )
                (*iseq) ++;
            else
                *iseq = u_zcfg.seq_min;
        }

        /* дļ */
        if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
        {
            if( f_fsn_write(u_fsnfile, *iseq) < 0 )
            {
                f_seterr("дļʧ", "O001", "OS", 9);
                f_err = -3;
                goto FTAM_END;
            }
        }

        /* Իӳٵĸ澯 */
        if( hdftime[0] )
        {
            f_delay_warn(hdftime, emsg[0] == 0 ? emsg : NULL);
        }

        /* ɹ״̬ */
        if( f_set_ok(lfname, hdftime, emsg) < 0 )
        {
            f_seterr("ʧ");
            f_err = -1;
            goto FTAM_END;
        }

        /* FTP  */
        if( u_zcfg.seq_ctrl == 1 || u_zcfg.warn_mode[WF_SEQBREAK] == '1' )
        {
            snprintf(zout, sizeof(zout), "%s/%s%s%s", u_logdir, OUTPREFIX, u_zcfg.no, OUTSUFFIX);

            if( u_zcfg.seq_sync && f_fsn_rz(t_ftpbuf1) < 0 )
            {
                z_rtrim(t_ftpbuf1);
                z_logv(zout, t_ftpbuf1);
                z_logv(u_logfile, "ϵͳļʧ");
            }
        }

        /* ¼ܼ */
        strncpy(u_pNidNormal->szFileName, lfname, sizeof(u_pNidNormal->szFileName) - 1);
        u_pNidNormal->szFileName[sizeof(u_pNidNormal->szFileName) - 1] = 0;
        u_pNidNormal->iFileSize = fsize;
        strcpy(u_pNidWarn->szFileName, u_pNidNormal->szFileName);

        f_nidlog(&u_nid_normal);

        z_logv(u_logfile, "Size=%ld", fsize);
        z_logv(u_logfile, "Ok!");
    }

FTAM_END:;

    /* Ͽ */
    if( getret == R_NOFILE || getret == 0 )
        r = ftiapi_release();
    else
        r = ftiapi_abort();

    if( r == 0 ) z_logv(u_logfile, "Ͽ OK");
    else
    {
        if( (b = ftiapi_getremoteerror()) ) 0;
        else if( (b = ftiapi_getlocalerror()) ) 0;
        else b = r + 500;

        sprintf(emsg, "ϿӴ=%d", b);
        f_seterr(emsg, "A101", "APP", 6);
        return(-2);
    }

    /* ־¼ɼ */
    if( getret )
    {
        sprintf(emsg, "ɼ=%d", getret);
        z_logv(u_logfile, emsg);

        if( getret == R_FAILURE )
        {
            return(R_RESTART);
        }
        else if( getret == R_NOSPACE )
        {
            sprintf(buf1, "%sļϵͳռ估Ŀ¼Ȩ", emsg);
            f_seterr(buf1, "O006", "OS", 9);
            return(-2);
        }
        else if( getret == R_NOFILE )
        {
            f_set_ok(NULL, NULL, "");
        }
    }

    return(f_err);
}

/*
 * Purpose          : Transfer a single file from the remote file system to
 *                    the local file system.
 *
 * Input parameters : char *infile   - remote file name discription
 *                    char *outfile  - local file name discription
 *                    int   delete   - whether delete remote file
 *
 * Output           : File copied to local system, or error reported.
 */
int ftam_fget(char *infile, char *outfile, int delflag)
{
    int r = 0, b = 0;

    /* docstat_type dt; */

    /*
     *   memset(&dt, 0, sizeof(dt));
     *   z_logv(u_logfile, "Stating ...");
     *
     *   if( (r = ftiapi_getattr(infile, &dt, 0)) )
     *   {
     *       if( (b = ftiapi_getremoteerror()) ) 0;
     *       else if( (b = ftiapi_getlocalerror()) ) 0;
     *       else b = r + 300;
     *
     *       z_logv(u_logfile, "error=%d", b);
     *       return(b);
     *   }
     */

    /* Get remote file to local file */
    z_logv(u_logfile, "Getting ...");

    if( (r = ftiapi_get(infile, outfile, "FTAM-3")) )
    {
        if( (b = ftiapi_getremoteerror()) ) 0;
        else if( (b = ftiapi_getlocalerror()) ) 0;
        else b = r + 300;

        z_logv(u_logfile, "error=%d", b);
        return(b);
    }

    /*
     * z_logv(u_logfile, "Deleting ...");
     *
     * if( delflag == 1 )
     * {
     *     if( (r = ftiapi_delete(infile)) )
     *     {
     *         if( (b = ftiapi_getremoteerror()) ) 0;
     *         else if( (b = ftiapi_getlocalerror()) ) 0;
     *         else b = r + 400;
     *
     *         z_logv(u_logfile, "error=%d", b);
     *         return(b);
     *     }
     * }
     */

    z_logv(u_logfile, "done");
    return(0);
}

