

#ifndef __SPICE_CLIENT_GSTAUDIO_H__
#define __SPICE_CLIENT_GSTAUDIO_H__

#include "spice-client.h"
#include "spice-audio.h"

G_BEGIN_DECLS

#define SPICE_TYPE_GSTAUDIO            (spice_gstaudio_get_type())
#define SPICE_GSTAUDIO(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), SPICE_TYPE_GSTAUDIO, SpiceGstaudio))
#define SPICE_GSTAUDIO_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), SPICE_TYPE_GSTAUDIO, SpiceGstaudioClass))
#define SPICE_IS_GSTAUDIO(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), SPICE_TYPE_GSTAUDIO))
#define SPICE_IS_GSTAUDIO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), SPICE_TYPE_GSTAUDIO))
#define SPICE_GSTAUDIO_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), SPICE_TYPE_GSTAUDIO, SpiceGstaudioClass))


typedef struct _SpiceGstaudio SpiceGstaudio;
typedef struct _SpiceGstaudioClass SpiceGstaudioClass;
typedef struct _SpiceGstaudioPrivate SpiceGstaudioPrivate;

struct _SpiceGstaudio {
    SpiceAudio parent;
    SpiceGstaudioPrivate *priv;
    
};

struct _SpiceGstaudioClass {
    SpiceAudioClass parent_class;
    
};

GType spice_gstaudio_get_type(void);

SpiceGstaudio *spice_gstaudio_new(SpiceSession *session,
                                  GMainContext *context, const char *name);

G_END_DECLS

#endif 

