/****************************
 в׳
 ****************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "z.h"
#include "base.h"
#include "DataSet.h"
#include "CICS_BkUniCall.h"

int SplitStr1(char **s, char *d, int *n, int l, char *b);

int main(int argc,char **argv)
{
    CIntRequest  req;
    CIntResponse resp;
    CBkUniCall   call(CICS_SYSTEM_ID);

    char telnum[21] = {0};
    char intid[33] = {0};
    char intcmd[33] = {0};
    char operid[33] = {0};
    char buf[128] = {0};
    char cfgfile[128] = {0};
    char ywname[128] = {0};
    char intmp[513] = {0};
    char sn[10] = {0};
    char region[6] = {0};
    char intag[128] = {0};
    char intagvalue[256] = {0};
    char *p = NULL;
    char ecode[33] = {0};
    char emsg[256] = {0};
    int jnum = 0;
    int timeout = 0;
    int r = 0;
    int i = 0;
    int j = 0;

    if( argc < 2 ){
        perror("ļ\n");
        exit(0);
    }
    strcpy(cfgfile, argv[1]);

    if( z_getkeyv(cfgfile, "TESTNAME", ywname, 127) != 0 ){
        strcpy(ywname,"");
    }

    if( z_getkeyv(cfgfile, "TIMEOUT", buf, 5) != 0 ){
        timeout = 60;
    }
    else
    {
        timeout = atoi(buf);
    }    

    if( z_getkeyv(cfgfile, "INTID", intid, 32) != 0 ){
        printf( "ļINTID!\n");
        return(-1);
    }
    if( z_getkeyv(cfgfile, "INTCMD", intcmd, 32) != 0 ){
        printf( "ļINTCMD!\n");
        return(-1);
    }
    if( z_getkeyv(cfgfile, "TELNUM", telnum, 20) != 0 ){
        //printf( "ļTELNUM!\n");
        //return(-1);
		strcpy(telnum,"");
    }
    if( z_getkeyv(cfgfile, "REGION", region, 5) != 0 ){
        //printf( "ļREGION!\n");
        //return(-1);
		strcpy(region,"");
    }
    if( z_getkeyv(cfgfile, "OPERID", operid, 32) != 0 ){
        //printf( "ļREGION!\n");
        //return(-1);
		strcpy(operid,intid);
    }

/* ------------------------------------------------- */
    z_lrtrim(intid);
    z_lrtrim(region);
    z_lrtrim(intid);
    z_lrtrim(telnum);
    z_lrtrim(intcmd);

    /* ·ɲ */
    strcpy(req.strIntID, intid);
    strcpy(req.strRegion, region);
    strcpy(req.strOperator, operid);
    strcpy(req.strTelnum, telnum);
    strcpy(req.strIntCmd, intcmd);
    req.transFlag = 1;

    CTagSet *in = new CTagSet;

    req.m_inParams.Add(in);

	printf("========================================\n");
    printf( "\nҵƣ[%s]\n",ywname);
    printf( "INTID[%s]\nINTCMD[%s]\nTELNUM[%s]\nREGION[%s]\nTIMEOUT[%d]\n", intid, intcmd, telnum, region, timeout);
    printf( "£\n");
    /* SetValue */
    for(i=1;i<100;i++)
    {
        memset(sn, 0, sizeof(sn));
        memset(intmp, 0, sizeof(intmp));
        memset(intag, 0, sizeof(intag));
        memset(intagvalue, 0, sizeof(intagvalue));

        snprintf(sn,9,"IN%d",i);
        if( z_getkeyv(cfgfile, sn, intmp, 512) != 0 ){
            break;
        }
        z_lrtrim(intmp);
        if(strlen(intmp) == 0){
            printf( "ļ[%s]Ϊ!\n", sn);
            return(-1);
        }
        p = intmp;
        
        SplitStr1(&p,intag,&jnum,32,":");
        strcpy(intagvalue,p);
        z_lrtrim(intag);
        z_lrtrim(intagvalue);
        printf("tag[%s]value[%s]\n", intag, intagvalue);
        in->SetValue(intag, intagvalue);
        
    }

	printf("----------------------------------------\n");
    printf( "ʼ÷ ............. \n");
    /* ÷ */
    for( i = 0; i < 2; i++ )
    {
        try
        {
            call.Invoke(req, resp, timeout);
            break;
        }
        catch(ECustom &e)
        {
            z_logsetonly1(1);
            printf("쳣ϢΪ:%s\n", e.Message);
            if( strstr(e.Message, "񲻿") ) sleep(1);
            if( i == 0 && strstr(e.Message, "·") ) call.Refresh(0);
            else 
            {
               	printf("========================================\n");
                return(-1);
            }
        }
    }

/* ----------------------------------------------------------------- */
    /* ȡӦϢ */
    if( (r = resp.m_outParams.GetSize()) == 0 )
    {
        printf( "ûзϢ\n");
        return(-1);
    }

	printf("----------------------------------------\n");
    printf( "ϣΪ:ض GetSize=%d \n", r);

    CTagSet *out  = NULL;
    CRSet   *crset = NULL;

    for( i = 0; i < r; i++ )
    {
        if( out == NULL ) out = dynamic_cast <CTagSet *> (resp.m_outParams.Get(i));
        if( crset == NULL ) crset = dynamic_cast <CRSet *> (resp.m_outParams.Get(i));
    }
    printf( "out=%p, crset=%p \n", out, crset);

/* ------------------------------------------------- */
    /* ȡֵ */
    memset(ecode, 0, sizeof(ecode));
    memset(emsg, 0, sizeof(emsg));

    if( out )
    {

        for( j = 0; j < out->Count(); j++ )
        {
            char *tag = NULL, *value = NULL;

            tag   = (char *) (*out)[j]->Tag.c_str();
            value = (char *) (*out)[j]->Value.EntityString;
            printf( "[outinfo] tag=[%s],    value=[%s]\n", tag, value);

            if( strcmp(tag, "RETCODE") == 0 )           // ش
            {
                strncpy(ecode, value, sizeof(ecode) - 1);
                ecode[ sizeof(ecode) - 1 ] = 0;
            }
            else if( strcmp(tag, "RETMSG") == 0 )       // Ϣ
            {
                strncpy(emsg, value, sizeof(emsg) - 1);
                emsg[ sizeof(emsg) - 1 ] = 0;
            }
        }
    }

    z_lrtrim(ecode);
    z_lrtrim(emsg);
	printf("----------------------------------------\n");
	if(crset!=NULL)
	{
	    printf("£\n");
    	printf("----------------------------------------\n");
    	printf("%d%d\n", crset->Rows(), crset->Cols());
		for( int m = 0; m < crset->Rows(); m++ ) {
		    printf("%d=",m);
			for ( int n = 0; n < crset->Cols(); n++ ) {
				printf("[%s]\t", crset->GetValue(m, n));
			}
			printf("\n");
		}    
    	printf("----------------------------------------\n");
	}

    printf( "\nRETCODE=[%s], RETMSG=[%s]\n", ecode, emsg);
	printf("========================================\n");

    return(0);
}

int SplitStr1(char **s, char *d, int *n, int l, char *b)
{
    int i, bl, f;
    if( (bl = strlen(b)) < 1) return(-1);    /* Ч */
    for(i = 0, f = 0, *n = 0; *(*s); (*s)++, (*n)++ ) {
        if( strncmp((*s), b, bl) == 0 ) {
            f = 1;
            (*s) += bl;
            break;
        }
        if( i < l ) d[i++] = *(*s);
    }
    d[i] = 0;
    if( f == 1 ) return(1);
    return(0);
}