/******************************
 (ͳһƽ̨)UAP ڴ
 ******************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/msg.h>
#include "uap_fdecl.h"
#include "uap_gvdecl.h"
#include "gcps.h"
#include "z.h"

#define   L_USAGEINF        66      /* ʾϢ */

void u_loadfile(char *);
void u_expfile(char *);

/****************
 ʾʹð
 ****************/
static void u_show_usage(void)
{
    printf("* -m                                                             *\n");
    printf("* -c cfile {-r zon | -s zon [-i ID]}                             *\n");
    printf("* -c cfile {-l file | -e file}                                   *\n");
    printf("* -c cfile -a area -t cut                                        *\n");
    printf("* -c cfile -a area -w way -u c,b,r -d date                       *\n");
    printf("*                                                                *\n");
    printf("* -m               --  㹲ڴ                      *\n");
    printf("* -c cfile         --  ָļ                              *\n");
    printf("* -r zon           --  ˢ(N P I U B F H C M)               *\n");
    printf("* -s zon [-i ID]   --  鿴(Gȫ)i ѡѡ޶ID       *\n");
    printf("* -a area -t cut   --  ޸ĵеĸ״̬                        *\n");
    printf("* -l file          --  ļ                                *\n");
    printf("* -e file          --  ļ                                *\n");
    printf("*                                                                *\n");
    printf("* -a area -w way -u c,b,r -d date --  ޸Ӧ״̬               *\n");
    printf("*     -wָ-dָӦʱ                                 *\n");
    printf("*     c b r ֱʾCRMBOSSԴӦ״̬                    *\n");
    printf("*                                                                *\n");
    printf("* ˵                                                     *\n");
    printf("*     G ȫ(ֻܲ鿴)  N ӵ  P Э  I IP֤  U û֤     *\n");
    printf("*     B ҵ  F ̽ű  H Ŷ  C   M Ʒӳ           *\n");
    printf("******************************************************************\n");
}

/****************
 ʾڴ
 ****************/
static void u_show_size(void)
{
    printf("ȫϢ  %8d\n", (int) ((long) (&((UAP_GINF *)0)->sCutOver)) );
    printf("Ϣ  %8d * %6ld = %ld\n", N_CUTOVER, sizeof(UAP_CUTOVER),  sizeof(u_pGInf->sCutOver));
    printf("ӦϢ  %8d * %6ld = %ld\n", N_URGE,    sizeof(UAP_URGE),     sizeof(u_pGInf->sUrge));
    printf("ӵϢ  %8d * %6ld = %ld\n", N_NODE,    sizeof(UAP_NODE),     sizeof(u_pGInf->sNode));
    printf("ЭϢ  %8d * %6ld = %ld\n", N_PROT,    sizeof(UAP_PROT),     sizeof(u_pGInf->sProt));
    printf("IP֤    %8d * %6ld = %ld\n", N_IPA,     sizeof(UAP_IPAUTH),   sizeof(u_pGInf->sIP));
    printf("û֤  %8d * %6ld = %ld\n", N_USRA,    sizeof(UAP_USERAUTH), sizeof(u_pGInf->sUser));
    printf("ҵϢ  %8d * %6ld = %ld\n", N_BUSI,    sizeof(UAP_BUSI),     sizeof(u_pGInf->sBusi));
    printf("ű  %8d * %6ld = %ld\n", N_FLOW,    sizeof(UAP_FLOW),     sizeof(u_pGInf->sFlow));
    printf("ű  %d\n", N_SCRIPT);
    printf("ŶϢ  %8d * %6ld = %ld\n", N_H3,      sizeof(UAP_H3),       sizeof(u_pGInf->sH3));
    printf("Ϣ%8d * %6ld = %ld\n", N_RCODE,   sizeof(UAP_RCODE),    sizeof(u_pGInf->sRCode));
    printf("Ʒӳ  %8d * %6ld = %ld\n", N_PMAP,    sizeof(UAP_PMAP),     sizeof(u_pGInf->sPMap));

    printf("ܼ      %ld\n", sizeof(UAP_GINF));
}

/************
 ALRMźŴ
 ************/
static void u_almsig(int sig)
{
    printf("ʱ\n˳\n\n");
    exit(0);
}

/**************
 
 **************/
static char *u_zone_name(int nZone)
{
    static char szBuf[64];

    switch( nZone )
    {
    case R_NODE:
        strcpy(szBuf, "ӵ");      break;
    case R_PROT:
        strcpy(szBuf, "Э");      break;
    case R_IPA:
        strcpy(szBuf, "IP֤");    break;
    case R_USRA:
        strcpy(szBuf, "û֤");  break;
    case R_BUSI:
        strcpy(szBuf, "ҵ");      break;
    case R_FLOW:
        strcpy(szBuf, "ű");      break;
    case R_H3:
        strcpy(szBuf, "Ŷ");      break;
    case R_GLOB:
        strcpy(szBuf, "ȫ");      break;
    case R_RCODE:
        strcpy(szBuf, "");    break;
    case R_PMAP:
        strcpy(szBuf, "Ʒӳ");  break;
    case R_CUTOVER:
        strcpy(szBuf, "");      break;
    case R_URGE:
        strcpy(szBuf, "Ӧ");      break;
    default:
        strcpy(szBuf, "");          break;
    }

    return( szBuf );
}

//===================================================================
//

int main(int argc, char **argv)
{
    int   c, b,
          fm, fc, fr, fs, fi,               /* ѡ־ */
          fa, ft, fu, fw, fd,
          fl, fe;

    int   nLen, nLeftL, nRightL;

    int   nZone,                            /*  */
          nArea,                            /*  */
          nCutOver;                         /* ӱ־ */

    char  szBuf[128],
          szCfgFile[256],                   /* ļ */
          szImageFile[256],                 /* ӳļ */
          szChannel[64],                    /*  */
          szEInfo[64],                      /* Ӧ״̬ */
          szETime[16],                      /* Ӧʱ */
          szID[64];                         /* ID */

    key_t kUap;

    struct sigaction sa;
    sigset_t st;

    // źŴ
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = 0;

    // INTQUITź
    sa.sa_handler = SIG_IGN;
    sigaction(SIGINT,  &sa, NULL);
    sigaction(SIGQUIT, &sa, NULL);

    // ָ TERM źŴ
    sa.sa_handler = SIG_DFL;
    sigaction(SIGTERM, &sa, NULL);

    //  ALRM źŴ
    sa.sa_handler = u_almsig;
    sigaction(SIGALRM, &sa, NULL);

    /* ܵ TERM ź */
    sigemptyset(&st);
    sigaddset(&st, SIGTERM);

    sigprocmask(SIG_UNBLOCK, &st, NULL);

    // ʾʾϢ
    printf("******************************************************************\n");
    printf("*                  UAP shared memory management                  *\n");

    sprintf(szBuf, "For %s  Ver %s (%s %s)", OSNOTE, VER, MAKEDATE, MAKETIME);

    nLen = strlen(szBuf);
    nLeftL = (L_USAGEINF - 2 - nLen) / 2;
    nRightL = L_USAGEINF - 2 - nLen - nLeftL;

    printf("*%*s%s%*s*\n", nLeftL, "", szBuf, nRightL, "");
    printf("******************************************************************\n");

    // ʼ
    b = c = 0;
    fc = fr = fs = fm = fi = fa = ft = fu = fw = fd = fl = fe = 0;

	nZone = 0;
	nArea = 0;
	nCutOver = -1;

    szID[0] = 0;
    szCfgFile[0] = 0;
    szImageFile[0] = 0;
    szChannel[0] = 0;
    szEInfo[0] = 0;
    szETime[0] = 0;

    while( (c = getopt(argc, argv, ":c:r:i:s:a:t:u:w:ml:e:d:")) != -1 )
    {
        switch (c)
        {
        case 'c':                             /* ļ */
            fc ++;
            strncpy(szCfgFile, optarg, sizeof(szCfgFile) - 1);
            szCfgFile[sizeof(szCfgFile) - 1] = 0;
            break;

        case 'r':                             /* ˢ² */
        case 's':                             /* 鿴 */
            if( c == 'r' ) fr ++;
            else fs++;

            nZone = optarg[0];                /* ͣ޶1 λ */
            break;

        case 'i':                             /* ޶ID */
            fi ++;
            strncpy(szID, optarg, sizeof(szID) - 1);
            szID[sizeof(szID) - 1] = 0;
            break;

        case 'a':                             /*  */
            fa ++;
            nArea = (int) strtol(optarg, (char **)NULL, 10);
            break;

        case 't':                             /* ӱ־ */
            ft ++;
            nCutOver = (int) strtol(optarg, (char **)NULL, 10);
            break;

        case 'w':                             /*  */
            fw ++;
            strncpy(szChannel, optarg, sizeof(szChannel) - 1);
            szChannel[sizeof(szChannel) - 1] = 0;
            break;

        case 'u':                             /* Ӧ״̬ */
            fu ++;
            strncpy(szEInfo, optarg, sizeof(szEInfo) - 1);
            szEInfo[sizeof(szEInfo) - 1] = 0;
            break;

        case 'd':                             /* Ӧʱ */
            fd ++;
            strncpy(szETime, optarg, sizeof(szETime) - 1);
            szETime[sizeof(szETime) - 1] = 0;
            break;

        case 'm':                             /* ڴ */
            fm ++;
            break;

        case 'l':                             /* ļ */
            fl ++;
            strncpy(szImageFile, optarg, sizeof(szImageFile) - 1);
            szImageFile[sizeof(szImageFile) - 1] = 0;
            break;

        case 'e':                             /* ļ */
            fe ++;
            strncpy(szImageFile, optarg, sizeof(szImageFile) - 1);
            szImageFile[sizeof(szImageFile) - 1] = 0;
            break;

        case ':':                             /* ȱѡ */
        case '?':                             /* Чѡ */
            b = -1;
            break;
        }
    }

    /* ﷨ */
    if( b == 0 )
    {
        if( (fm + fc != 1) ||                 /* m,c ѡһ */

            /* ظѡ */
            (fr > 1 || fs > 1 || fi > 1) ||

            /* r,s,a,l,e ѡ 5һ */
            (fc == 1 && fr + fs + fa + fl + fe != 1) ||

            /* r,s,a,l,e ѡ cѡ */
            (fc == 0 && fr + fs + fa + fl + fe != 0) ||

            /* i ѡ sѡ */
            (fi == 1 && fs == 0) ||

            /* d ѡ uѡ */
            (fd == 1 && fu == 0) ||

            /* u,w ѡ */
            ((fw == 1 && fu == 0) || (fw == 0 && fu == 1)) ||

            /* t,u ѡ aѡ */
            (ft + fu && fa == 0) ||

            /* ָa ѡҪͬʱָt,u ѡ */
            (fa == 1 && ft + fu == 0) ||

            /*  */
            (optind < argc) )
        {
             b = -1;
        }
    }

    if( b < 0 )
    {
        u_show_usage();                 /* ʾ */
        return(1);
    }

    // ϷԼ
    if( fr == 1 && nZone == R_GLOB )
    {
        printf("󣺲ˢȫ\n");
        return(-1);
    }

    if( fr == 1 || fs == 1 )
    {
        if( strcmp(u_zone_name(nZone), "") == 0 )
        {
            printf("Ч'%c'\n", nZone);
            return(-1);
        }
    }

    u_set_outsys(0);

    if( fm == 1 )                       /* ʾڴ */
    {
        u_show_size();
        return(0);
    }

    // ȡļKEY ֵ
    if( z_getkeyv(szCfgFile, SG_UAPKEY, szBuf, sizeof(szBuf) - 1) )
    {
        printf("ļ '%s' ûж %s\n", szCfgFile, SG_UAPKEY);
        return(-1);
    }

    // 16ƶ
    kUap = (int) strtol(szBuf, (char **)NULL, 16);

    b = 0;

    // ȡIPC
    if( u_get_ipc(kUap) < 0 )
    {
        b = -1;
    }
    else
    {
        // ڴ
        if( u_pGInf->nMemSize != sizeof(UAP_GINF) )
        {
            b = -2;
            printf("ʾڴṹԭйڴѹ\n");
        }
    }

    // ½ڴ桢źŵ
    if( fr == 1 || fl == 1 )
    {
        if( b == -2 )
        {
            printf("ʾɾڵIPC ... ");
            fflush(stdout);

            if( u_clean_ipc() < 0 )
            {
                printf("ʧ\n");
                return(-1);
            }
            printf("OK.\n");
        }

        if( b < 0 )
        {
            printf("ʾ½IPC  ... ");
            fflush(stdout);

            if( u_init_ipc(kUap, szCfgFile, sizeof(UAP_GINF)) < 0 )
            {
                printf("ʧ\n");
                return(-1);
            }
            printf("OK.\n");
        }
    }
    else if( b < 0 )
    {
        printf("IPC ʧ\n");
        return(-1);
    }

    if( fr == 1 )                   /* ˢڴ */
    {
        if( u_refresh_zone(szCfgFile, nZone) == 0 )
            printf("OK '%s' ˢOK\n", u_zone_name(nZone));
    }
    else if( fl == 1 )              /* ļ */
    {
        u_loadfile(szImageFile);
    }
    else if( fe == 1 )              /* ļ */
    {
        u_expfile(szImageFile);
    }
    else if( fs == 1 )              /* 鿴ڴ */
    {
        u_show_zone(nZone, szID);
    }
    else if( ft == 1 )              /* ޸ĵи״̬ */
    {
        if( nCutOver < -1 || nCutOver > 1 )
        {
            printf("Чӱ־ %d\n", nCutOver);
            return(1);
        }

        if( u_set_cutover(nArea, nCutOver) == 1 )
            printf("OK ״̬޸OK\n");
    }
    else if( fu == 1 )              /* ޸Ӧ״̬ */
    {
        if( u_set_urge(nArea, szChannel, szEInfo, szETime) == 1 )
            printf("OK Ӧ״̬޸OK\n");
    }

    return(0);
}

// ļ
void u_loadfile(char *pFile)
{
    FILE *fp;
    struct stat st;

    if( stat(pFile, &st) < 0 )
    {
        perror(pFile);
        return;
    }

    if( st.st_size != sizeof(UAP_GINF) )
    {
        printf(": ļС=%ld, ڴС=%ld, ƥ\n", st.st_size, sizeof(UAP_GINF));
        return;
    }

    if( (fp = fopen(pFile, "r")) == NULL )
    {
        perror(pFile);
        return;
    }

    printf("loading from file %s ... ", pFile);
    fflush(stdout);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        printf("ˢ¼ʧ\n");
        return;
    }

    if( fread(u_pGInf, u_pGInf->nMemSize, 1, fp) != 1 )
    {
        perror(pFile);
        return;
    }

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        printf("ˢ½ʧ\n");
        return;
    }

    fclose(fp);
    printf("OK\n");
}

// ļ
void u_expfile(char *pFile)
{
    FILE *fp;

    if( (fp = fopen(pFile, "w")) == NULL )
    {
        perror(pFile);
        return;
    }

    printf("writing to file %s ... ", pFile);
    fflush(stdout);

    if( fwrite(u_pGInf, u_pGInf->nMemSize, 1, fp) != 1 )
    {
        perror(pFile);
        return;
    }

    fclose(fp);
    printf("OK\n");
}

