//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "BatchDo.h"
#include "Config.h"
#include "Fpub.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFrmBatchDo *FrmBatchDo;
//---------------------------------------------------------------------------
__fastcall TFrmBatchDo::TFrmBatchDo(TComponent* Owner) : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TFrmBatchDo::FormShow(TObject *Sender)
{
        int    k, j, N;
        String pClassName;

        TCheckBox   *pChkBox   = NULL;
        TEdit       *pEdit     = NULL;
        TCheckBox   *pChkBox1  = NULL;
        TRadioGroup *pRadiogrp = NULL;

        m_FrmUpdate = static_cast<TFrmBatchUpdate *>(Owner);

        EditHostPair->Text = m_FrmUpdate->u_szHostPair;
        EditPassPair->Text = m_FrmUpdate->u_szPassPair;
        EditFileAnalyzer->Text = m_FrmUpdate->u_szFileAnalyzer;
        EditSrcPattern->Text = m_FrmUpdate->u_szSrcPattern;
        EditDstPath->Text = m_FrmUpdate->u_szDstPath;
        EditDstNameFormat->Text = m_FrmUpdate->u_szDstNameFormat;
        EditBusyItv->Text = m_FrmUpdate->u_iBusyItv;
        EditFreeItv->Text = m_FrmUpdate->u_iFreeItv;
        EditNoLimit->Text = m_FrmUpdate->u_iNoLimit;
        EditExtraCopy->Text = m_FrmUpdate->u_iExtraCopy;

        // ѡǷʹá
        N = sizeof(m_FrmUpdate->u_iCheck) / sizeof(int);
        for( int i = 1; i <= N; i++ )
        {
                pChkBox   = NULL;
                pEdit     = NULL;
                pChkBox1  = NULL;
                pRadiogrp = NULL;

                if( (k = SeekComponent(this, i)) >= 0 )
                {
                        pChkBox = static_cast<TCheckBox *>(this->Components[k]);
                        if( (j = SeekComponent(this, 100 + pChkBox->Tag)) >= 0 )
                        {
                                // ȷ
                                pClassName = Components[j]->ClassName();

                                if( pClassName == "TRadioGroup" ) pRadiogrp = static_cast<TRadioGroup *>(Components[j]);
                                if( pClassName == "TCheckBox" ) pChkBox1 = static_cast<TCheckBox *>(Components[j]);
                                if( pClassName == "TEdit" ) pEdit = static_cast<TEdit *>(Components[j]);
                        }

                        // Ӧ
                        if( m_FrmUpdate->u_iCheck[i - 1] == 1 )
                        {
                                pChkBox->Checked = true;
                                if( pEdit )
                                {
                                        pEdit->Enabled = true;
                                        pEdit->Color = clWindow;
                                }
                                else if( pChkBox1 )
                                {
                                        pChkBox1->Enabled = true;
                                }
                                else if( pRadiogrp )
                                {
                                        pRadiogrp->Enabled = true;
                                }
                        }
                        else
                        {
                                pChkBox->Checked = false;
                                if( pEdit )
                                {
                                        pEdit->Enabled = false;
                                        pEdit->Color = clGrayText;
                                }
                                else if( pChkBox1 )
                                {
                                        pChkBox1->Enabled = false;
                                }
                                else if( pRadiogrp )
                                {
                                        pRadiogrp->Enabled = false;
                                }
                        }
                }
        }
}

//---------------------------------------------------------------------------
void __fastcall TFrmBatchDo::ChkPublicClick(TObject *Sender)
{
        int k;

        TCheckBox *pChkBox = NULL;
        TEdit     *pEdit = NULL;

        pChkBox = static_cast<TCheckBox *>(Sender);
        if( pChkBox == NULL ) return;

        if( (k = SeekComponent(this, 100 + pChkBox->Tag)) >= 0 )
        {
                pEdit = static_cast<TEdit *>(Components[k]);
        }
        if( pEdit == NULL ) return;

        if( pChkBox->Checked == true )
        {
                pEdit->Enabled = true;
                pEdit->Color = clWindow;
        }
        else
        {
                pEdit->Enabled = false;
                pEdit->Color = clGrayText;
        }
}

//---------------------------------------------------------------------------
// ޸ĸֵ
void __fastcall TFrmBatchDo::BtnSetClick(TObject *Sender)
{
        int i, k, N;

        TCheckBox *pChkBox;

        // ΪǷʹá鸳ֵ
        memset(m_FrmUpdate->u_iCheck, 0, sizeof(m_FrmUpdate->u_iCheck));

        N = sizeof(m_FrmUpdate->u_iCheck) / sizeof(int);
        for( i = 1; i < N; i++ )
        {
                if( (k = SeekComponent(this, i)) >= 0 )
                {
                        pChkBox = static_cast<TCheckBox *>(this->Components[k]);
                        if( pChkBox->Checked == true )
                                m_FrmUpdate->u_iCheck[i - 1] = 1;
                        else
                                m_FrmUpdate->u_iCheck[i - 1] = 0;
                }
        }

        strcpy(m_FrmUpdate->u_szHostPair, EditHostPair->Text.Trim().c_str());
        strcpy(m_FrmUpdate->u_szPassPair, EditPassPair->Text.Trim().c_str());
        strcpy(m_FrmUpdate->u_szDstPath, EditDstPath->Text.Trim().c_str());
        strcpy(m_FrmUpdate->u_szFileAnalyzer, EditFileAnalyzer->Text.Trim().c_str());
        strcpy(m_FrmUpdate->u_szSrcPattern, EditSrcPattern->Text.Trim().c_str());
        strcpy(m_FrmUpdate->u_szDstNameFormat, EditDstNameFormat->Text.Trim().c_str());

        if( ChkBusyItv->Checked == true )
        {
                if( EditBusyItv->Text.Trim().Length() == 0 )
                {
                        ErrDlg("æʱɼڿ");
                        return;
                }
                try
                {
                        m_FrmUpdate->u_iBusyItv = EditBusyItv->Text.ToInt();
                }
                catch (...)
                {
                        ErrDlg("æʱɼڷǷ");
                        return;
                }
                if( m_FrmUpdate->u_iBusyItv <= 0 )
                {
                        ErrDlg("æʱɼڷǷ");
                        return;
                }
        }

        // ʱɼ
        if( EditFreeItv->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_FrmUpdate->u_iFreeItv = EditFreeItv->Text.Trim().ToInt();
                }
                catch (...)
                {
                }
        }

        if( m_FrmUpdate->u_iFreeItv <= 0 )
        {
                m_FrmUpdate->u_iFreeItv = m_FrmUpdate->u_iBusyItv;
                EditFreeItv->Text = m_FrmUpdate->u_iBusyItv;
        }

        if( EditNoLimit->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_FrmUpdate->u_iNoLimit = EditNoLimit->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("޻澯ʱ޷Ƿ");
                        return;
                }
        }

        if( EditExtraCopy->Text.Trim().Length() > 0 )
        {
                try
                {
                        m_FrmUpdate->u_iExtraCopy = EditExtraCopy->Text.Trim().ToInt();
                }
                catch (...)
                {
                        ErrDlg("⿽Ƿ");
                        return;
                }
        }

        ModalResult = mrOk;
        return;
}
//---------------------------------------------------------------------------

